
local timeInit = 0
local initTimer = 1
local Now = 0

local StartingMinute = -1
local EndingMinute = -1

local myMapSize = "UNKNOWN"
local mySlowTime = "UNKNOWN"

local myTimeWarpFactor = 0
local timeWarpFound = false

local timeTot = 0
local timeAnim = 0
local timePerAnim = 0.5
local Set = Object.SetProperty
local Get = Object.GetProperty
local Find = Object.GetNearbyObjects
local markerFound = false
local previewShown = false
local OtherGarageAvailable = false

local InventoryRepairSpots = "missing"
local InventoryPartsRack = "missing"
local InventoryControl = "missing"
local InventoryServiceDesk = "missing"
local InventoryCabinet = "missing"

function DeleteMyRoadMarker()
    local roadMarkers = Find(this,"RoadMarker",1500)
	if next(roadMarkers) then
		for thatMarker,dist in pairs(roadMarkers) do
			if thatMarker.Pos.x == this.OrigX then
				thatMarker.Delete()
				break
			end
		end
	end
	roadMarkers = nil
end

function FindMapEdge()
	local endY=-1
	local foundEndY=false
	
	while foundEndY==false do
		endY=endY+1
		local myCell = World.GetCell(this.Pos.x,endY)
		if myCell.Mat==nil then
			foundEndY=true
			endY=endY-1
		end
	end
	Set(this,"MapBottom",endY)
end

function Create()
	Set(this,"HomeUID","GantryCrane2_"..me["id-uniqueId"])
	Set(this,"StartBuilding",false)
	Set(this,"GaragePlacement","Centre")
	Set(this,"GarageSize","Normal")
	Set(this,"IsMilitary","No")
	Set(this,"RailLeftX",-10.5)
	Set(this,"RailRightX",11.5)
	Set(this,"RailsY",12.5)
	Set(this,"GantryCraneX",0.5)
	Set(this,"Xmin",-9.5)
	Set(this,"Xmax",10)
	Set(this,"Ymin",-5.5)
	Set(this,"Ymax",11.5)
	Set(this,"MaxLimos",8)
	this.Tooltip = "tooltip_Init_TimeWarpA"
	this.HasCustomReport = true		-- comment out to get the old buttons
end

function toggleGaragePlacementClicked()
	if this.GaragePlacement == "Centre" then
		this.GaragePlacement = "Left"
	elseif this.GaragePlacement == "Left" then
		this.GaragePlacement = "Right"
	else
		this.GaragePlacement = "Centre"
		if this.GarageSize == "Wide" then
			this.GarageSize = "Normal"
			this.SetInterfaceCaption("toggleGarageSize", "tooltip_Button_GarageSize","tooltip_Button_"..this.GarageSize,"X")
			if Interface.SetComponentProperties ~= nil then
				Interface.SetComponentProperties( "MySize", { Replacements = { S = "reportTooltip_Size"..this.GarageSize } } )
			end
		end
	end
	SetCoordinates()
	this.SetInterfaceCaption("toggleGaragePlacement", "tooltip_Button_GaragePlacement","tooltip_Button_"..this.GaragePlacement,"X")
	if Interface.SetComponentProperties ~= nil then
		Interface.SetComponentProperties( "MyPlacement", { Replacements = { R = "reportTooltip_Placement"..this.GaragePlacement } } )
	end
end

function toggleGarageSizeClicked()
	if this.GarageSize == "Normal" then
		if not Get(this,"TallNotPossible") then
			this.GarageSize = "Tall"
		else
			this.GarageSize = "Wide"
			if this.GaragePlacement == "Centre" then
				this.GaragePlacement = "Left"
				this.SetInterfaceCaption("toggleGaragePlacement", "tooltip_Button_GaragePlacement","tooltip_Button_"..this.GaragePlacement,"X")
				if Interface.SetComponentProperties ~= nil then
					Interface.SetComponentProperties( "MyPlacement", { Replacements = { R = "reportTooltip_Placement"..this.GaragePlacement } } )
				end
			end
		end
	elseif this.GarageSize == "Tall" then
		this.GarageSize = "Wide"
		if this.GaragePlacement == "Centre" then
			this.GaragePlacement = "Left"
			this.SetInterfaceCaption("toggleGaragePlacement", "tooltip_Button_GaragePlacement","tooltip_Button_"..this.GaragePlacement,"X")
			if Interface.SetComponentProperties ~= nil then
				Interface.SetComponentProperties( "MyPlacement", { Replacements = { R = "reportTooltip_Placement"..this.GaragePlacement } } )
			end
		end
	else
		this.GarageSize = "Normal"
	end
	SetCoordinates()
	this.SetInterfaceCaption("toggleGarageSize", "tooltip_Button_GarageSize","tooltip_Button_"..this.GarageSize,"X")
	if Interface.SetComponentProperties ~= nil then
		Interface.SetComponentProperties( "MySize", { Replacements = { S = "reportTooltip_Size"..this.GarageSize } } )
	end
end

function SetCoordinates()
	if this.GaragePlacement == "Centre" then
		this.RailLeftX = -10.5
		this.RailRightX = 11.5
		this.GantryCraneX = 0.5
		this.Xmin = -9.5
		this.Xmax = 10.5
		if this.GarageSize == "Normal" then
			this.RailsY = 12.5
			this.Ymin = -5.5
			this.Ymax = 11.5
			Set(this,"MaxLimos",8)
		elseif this.GarageSize == "Tall" then
			this.RailsY = 22.5
			this.Ymin = -5.5
			this.Ymax = 21.5
			Set(this,"MaxLimos",16)
		end
	elseif this.GaragePlacement == "Left" then
		this.RailLeftX = -12.5
		this.RailRightX = 3.5
		this.GantryCraneX = -4.5
		this.Xmin = -11.5
		this.Xmax = 2.5
		if this.GarageSize == "Normal" then
			this.RailsY = 12.5
			this.Ymin = -5.5
			this.Ymax = 11.5
			Set(this,"MaxLimos",8)
		elseif this.GarageSize == "Tall" then
			this.RailsY = 22.5
			this.Ymin = -5.5
			this.Ymax = 21.5
			Set(this,"MaxLimos",16)
		elseif this.GarageSize == "Wide" then
			this.RailLeftX = -18.5
			this.GantryCraneX = -7.5
			this.Xmin = -17.5
			this.RailsY = 12.5
			this.Ymin = -5.5
			this.Ymax = 11.5
			Set(this,"MaxLimos",16)
		end
	else
		this.RailLeftX = -3.5
		this.RailRightX = 12.5
		this.GantryCraneX = 4.5
		this.Xmin = -2.5
		this.Xmax = 11.5
		if this.GarageSize == "Normal" then
			this.RailsY = 12.5
			this.Ymin = -5.5
			this.Ymax = 11.5
			Set(this,"MaxLimos",8)
		elseif this.GarageSize == "Tall" then
			this.RailsY = 22.5
			this.Ymin = -5.5
			this.Ymax = 21.5
			Set(this,"MaxLimos",16)
		elseif this.GarageSize == "Wide" then
			this.RailRightX = 18.5
			this.GantryCraneX = 7.5
			this.Xmax = 17.5
			this.RailsY = 12.5
			this.Ymin = -5.5
			this.Ymax = 11.5
			Set(this,"MaxLimos",16)
		end
	end
end

function toggleShowPreviewClicked()
	if previewShown == false then
		SetCoordinates()
		previewRailLeft = Object.Spawn("GantryRail2Preview",this.OrigX+this.RailLeftX,this.OrigY+this.RailsY)
		Set(previewRailLeft,"HomeUID",this.HomeUID)
		if this.GarageSize == "Tall" then previewRailLeft.SubType = 1 end
		previewRailRight = Object.Spawn("GantryRail2Preview",this.OrigX+this.RailRightX,this.OrigY+this.RailsY)
		Set(previewRailRight,"HomeUID",this.HomeUID)
		if this.GarageSize == "Tall" then previewRailRight.SubType = 1 end
		previewGantry = Object.Spawn("GantryCrane2Preview",this.OrigX+this.GantryCraneX,this.OrigY)
		Set(previewGantry,"HomeUID",this.HomeUID)
		if this.GaragePlacement ~= "Centre" then previewGantry.SubType = 1 end
		if this.GarageSize == "Wide" then previewGantry.SubType = 0 end
		previewShown = true
	else
		local Crane = Find(this,"GantryCrane2Preview",50)
		if next(Crane) then
			for thatCrane, dist in pairs(Crane) do
				if thatCrane.HomeUID == this.HomeUID then
					thatCrane.Delete()
				end
			end
		end
		local Rails = Find(this,"GantryRail2Preview",50)
		if next(Rails) then
			for thatRail, dist in pairs(Rails) do
				if thatRail.HomeUID == this.HomeUID then
					thatRail.Delete()
				end
			end
		end
		previewShown = false
	end
end

function toggleBuildFloorClicked()
	if this.StartBuilding == false then
		SetCoordinates()
		Set(this,"StartBuilding",true)
	end
end

function FindInSquare(theObject) -- returns target objects in my garage
	local ListOfObjects = this.GetNearbyObjects(theObject,50)
	for thatObject, distance in pairs(ListOfObjects) do
		--print("scanning position for object"..theObject)
		if (thatObject.Pos.x>=math.floor(this.OrigX+this.Xmin) and thatObject.Pos.x<=math.ceil(this.OrigX+this.Xmax)) and (thatObject.Pos.y>=math.floor(this.OrigY+this.Ymin) and thatObject.Pos.y<=math.ceil(this.OrigY+this.Ymax)) then
		-- it's ok, put other stuff here if you need
		else
			ListOfObjects[thatObject]=nil -- remove the out of bounds object from the list
		end
	end
	return ListOfObjects
end

function toggleScanInventoryClicked()
	local GantryControlOK = false
	--print("find GantryCrane2BoothPreview")
    local myGantryControls = FindInSquare("GantryCrane2BoothPreview")
	if next(myGantryControls) then
		Interface.RemoveComponent(this,"Caption_PlaceBooth", "Caption", "tooltip_Caption_PlaceBooth")
		GantryControlOK = true
		InventoryControl = "OK"
		--print("GantryCrane2BoothPreview OK")
	else
		Interface.AddComponent(this,"Caption_PlaceBooth", "Caption", "tooltip_Caption_PlaceBooth")
		InventoryControl = "missing"
	end
	myGantryControls = nil
	
	local RepairSpotsOK = false
	local PaintSpotsOK = false
	--print("find Limo2Preview")
    local myRepairSpots = FindInSquare("Limo2Preview")
	if next(myRepairSpots) then
		RepairSpotsOK = true
		InventoryRepairSpots = "OK"
		Interface.RemoveComponent(this,"Caption_PlaceRepairSpots", "Caption", "tooltip_Caption_PlaceRepairSpots")
		--print("Limo2Preview OK")
		for thatSpot, dist in pairs(myRepairSpots) do
			if thatSpot.SpotType == "Paint" then
				PaintSpotsOK = true
			end
			break
		end
	else
		Interface.AddComponent(this,"Caption_PlaceRepairSpots", "Caption", "tooltip_Caption_PlaceRepairSpots")
		InventoryRepairSpots = "missing"
	end
	myRepairSpots = nil
	
	local RackOK = false
	--print("find CarPartsRack2Preview")
    local myRacks = FindInSquare("CarPartsRack2Preview")
	if next(myRacks) then
		RackOK = true
		Interface.RemoveComponent(this,"Caption_PlaceRack", "Caption", "tooltip_Caption_PlaceRack")
		--print("CarPartsRack2Preview OK")
		InventoryPartsRack = "OK"
	elseif PaintSpotsOK == true then
		RackOK = true
		Interface.RemoveComponent(this,"Caption_PlaceRack", "Caption", "tooltip_Caption_PlaceRack")
		--print("Paintspots found, parts rack not required, CarPartsRack2Preview OK")
		InventoryPartsRack = "OK"
	else
		Interface.AddComponent(this,"Caption_PlaceRack", "Caption", "tooltip_Caption_PlaceRack")
		InventoryPartsRack = "missing"
	end
	myRacks = nil
	
	local DeskOK = false
	--print("find ServiceDesk2Preview")
    local myDesk = FindInSquare("Limo2ServiceDeskPreview")
	if next(myDesk) then
		DeskOK = true
		Interface.RemoveComponent(this,"Caption_PlaceDesk", "Caption", "tooltip_Caption_PlaceDesk")
		--print("ServiceDesk2Preview OK")
		InventoryServiceDesk = "OK"
	else
		Interface.AddComponent(this,"Caption_PlaceDesk", "Caption", "tooltip_Caption_PlaceDesk")
		InventoryServiceDesk = "missing"
	end
	myDesk = nil
	
	local FilingOK = false
	--print("find Limo2FilingCabinetPreview")
    local myFiling = FindInSquare("Limo2FilingCabinetPreview")
	if next(myFiling) then
		FilingOK = true
		Interface.RemoveComponent(this,"Caption_PlaceFiling", "Caption", "tooltip_Caption_PlaceFiling")
		InventoryCabinet = "OK"
		--print("Limo2FilingCabinetPreview OK")
	else
		Interface.AddComponent(this,"Caption_PlaceFiling", "Caption", "tooltip_Caption_PlaceFiling")
		InventoryCabinet = "missing"
	end
	myFiling = nil
	
	if Interface.SetComponentProperties ~= nil then
		Interface.SetComponentProperties( "FloorDone2", { Replacements = { A = InventoryRepairSpots, B = InventoryPartsRack, C = InventoryControl, D = InventoryServiceDesk, E = InventoryCabinet } } )
	end
	
	if GantryControlOK == true and RackOK == true and RepairSpotsOK == true and DeskOK == true and FilingOK == true then
	
		local myGantryControls = FindInSquare("GantryCrane2BoothPreview")
		if next(myGantryControls) then
			for thatBooth, dist in pairs(myGantryControls) do
				MyCraneBooth = Object.Spawn("GantryCrane2Booth",thatBooth.Pos.x,thatBooth.Pos.y)
				Set(MyCraneBooth,"TimeWarp",this.TimeWarp)
				thatBooth.Delete()
				Set(MyCraneBooth,"HomeUID",this.HomeUID)
				Set(MyCraneBooth,"TrafficLightUpgrade",true)
			end
		end
		myGantryControls = nil
	
		local myRacks = FindInSquare("CarPartsRack2Preview")
		if next(myRacks) then
			for thatRack, dist in pairs(myRacks) do
				MyRack = Object.Spawn("CarPartsRack2",thatRack.Pos.x,thatRack.Pos.y)
				Set(MyRack,"HomeUID",this.HomeUID)
				Set(MyRack,"Tooltip","HomeUID: "..this.HomeUID)
				Set(MyRack,"Slot0X",thatRack.Pos.x-1.5)
				Set(MyRack,"Slot0Y",thatRack.Pos.y)
				Set(MyRack,"Slot1X",thatRack.Pos.x-0.5)
				Set(MyRack,"Slot1Y",thatRack.Pos.y)
				Set(MyRack,"Slot2X",thatRack.Pos.x+0.5)
				Set(MyRack,"Slot2Y",thatRack.Pos.y)
				Set(MyRack,"Slot3X",thatRack.Pos.x+1.5)
				Set(MyRack,"Slot3Y",thatRack.Pos.y)
				Set(MyRack,"Slot4X",thatRack.Pos.x-1.5)
				Set(MyRack,"Slot4Y",thatRack.Pos.y-1)
				Set(MyRack,"Slot5X",thatRack.Pos.x-0.5)
				Set(MyRack,"Slot5Y",thatRack.Pos.y-1)
				Set(MyRack,"Slot6X",thatRack.Pos.x+0.5)
				Set(MyRack,"Slot6Y",thatRack.Pos.y-1)
				Set(MyRack,"Slot7X",thatRack.Pos.x+1.5)
				Set(MyRack,"Slot7Y",thatRack.Pos.y-1)
				thatRack.Delete()
			end
		end
		myRacks = nil
	
		BuildGarage()
		
		local myRepairSpots = FindInSquare("Limo2Preview")
		if next(myRepairSpots) then
			local RepairSpot = 0
			for thatSpot,dist in pairs(myRepairSpots) do
				Set(MyCraneBooth,"SpotType"..RepairSpot,thatSpot.SpotType)
				if thatSpot.SpotType == "Repair" then
					MakeCarSpotsFloor(thatSpot.Pos.x-1,thatSpot.Pos.y-2)
					Set(MyCraneBooth,"Slot"..RepairSpot.."X",thatSpot.Pos.x)
					Set(MyCraneBooth,"Slot"..RepairSpot.."Y",thatSpot.Pos.y-0.5)
					Set(MyCraneBooth,"SpotType"..RepairSpot,thatSpot.SpotType)
					Set(MyCraneBooth,"ttSlot"..RepairSpot,"Empty Repair Spot")
				else
					newPaint = Object.Spawn("GantryCrane2PaintCabin",thatSpot.Pos.x,thatSpot.Pos.y)
					Set(newPaint,"HomeUID",this.HomeUID)
					Set(newPaint,"Tooltip","HomeUID: "..this.HomeUID)
					Set(MyCraneBooth,"Slot"..RepairSpot.."X",thatSpot.Pos.x)
					Set(MyCraneBooth,"Slot"..RepairSpot.."Y",thatSpot.Pos.y-0.5)
					Set(MyCraneBooth,"SpotType"..RepairSpot,thatSpot.SpotType)
					Set(MyCraneBooth,"ttSlot"..RepairSpot,"Empty Paint Spot")
				end
				RepairSpot = RepairSpot + 1
				thatSpot.Delete()
			end
		end
		
		local myLessonSpots = FindInSquare("Limo2LessonPreview")
		if next(myLessonSpots) then
			local LessonSpot = 1
			for thatSpot,dist in pairs(myLessonSpots) do
				newLessonCar = Object.Spawn("Limo2Lesson",thatSpot.Pos.x,thatSpot.Pos.y)
				if this.IsMilitary == "Yes" then newLessonCar.SubType = 1 end
				Set(newLessonCar,"HomeUID",this.HomeUID)
				Set(newLessonCar,"LessonSpot",LessonSpot)
				Set(newLessonCar,"CountDown",false)
				Set(newLessonCar,"EngineJobIssued",false)
				Set(newLessonCar,"Tooltip","HomeUID: "..this.HomeUID)
				MakeLessonCarFloor(thatSpot.Pos.x-1,thatSpot.Pos.y-1)
				Set(MyCraneBooth,"Lesson"..LessonSpot.."ID",newLessonCar.Id.i)
				Set(MyCraneBooth,"LessonSpot"..LessonSpot.."X",thatSpot.Pos.x)
				Set(MyCraneBooth,"LessonSpot"..LessonSpot.."Y",thatSpot.Pos.y-1.25)
				Set(MyCraneBooth,"ttLessonSlot"..LessonSpot,"Empty Lesson Spot")
				LessonSpot = LessonSpot + 1
				thatSpot.Delete()
			end
		end
		
		local s = 7
		if this.GarageSize == "Tall" or this.GarageSize == "Wide" then s = 15 end
		for j=0,s do
			if Get(MyCraneBooth,"Slot"..j.."X") == nil then
				Set(MyCraneBooth,"ttSlot"..j,"(not in use)")
			end
		end
		
		for j=1,10 do
			if Get(MyCraneBooth,"LessonSpot"..j.."X") == nil then
				Set(MyCraneBooth,"ttLessonSlot"..j,"(not in use)")
			end
		end
		
		local myServiceDesks = FindInSquare("Limo2ServiceDeskPreview")
		if next(myServiceDesks) then
			for thatServiceDesk, dist in pairs(myServiceDesks) do
				MyServiceDesk = Object.Spawn("Limo2ServiceDesk",thatServiceDesk.Pos.x,thatServiceDesk.Pos.y)
				Set(MyServiceDesk,"TimeWarp",this.TimeWarp)
				if thatServiceDesk.SubType == 0 then	-- translate the RotateType 4 from the preview desk
					Set(MyServiceDesk,"Or.x",0)			-- into RotateType 1 for the real desk
					Set(MyServiceDesk,"Or.y",1)
				elseif thatServiceDesk.SubType == 1 then
					Set(MyServiceDesk,"Or.x",0)
					Set(MyServiceDesk,"Or.y",-1)
				elseif thatServiceDesk.SubType == 2 then
					MyServiceDesk.Pos.y = MyServiceDesk.Pos.y - 0.5
					Set(MyServiceDesk,"Or.x",-1)
					Set(MyServiceDesk,"Or.y",0)
				elseif thatServiceDesk.SubType == 3 then
					MyServiceDesk.Pos.y = MyServiceDesk.Pos.y - 0.5
					Set(MyServiceDesk,"Or.x",1)
					Set(MyServiceDesk,"Or.y",0)
				end
				thatServiceDesk.Delete()
				Set(MyServiceDesk,"HomeUID",this.HomeUID)
				Set(MyServiceDesk,"Tooltip","HomeUID: "..this.HomeUID)
			end
		end
		myServiceDesks = nil
	
		local myFiling = FindInSquare("Limo2FilingCabinetPreview")
		if next(myFiling) then
			for thatFiling, dist in pairs(myFiling) do
				MyFilingCabinet = Object.Spawn("Limo2FilingCabinet",thatFiling.Pos.x,thatFiling.Pos.y)
				if thatFiling.SubType == 0 then
					Set(MyFilingCabinet,"Or.x",0)
					Set(MyFilingCabinet,"Or.y",1)
				elseif thatFiling.SubType == 1 then
					Set(MyFilingCabinet,"Or.x",0)
					Set(MyFilingCabinet,"Or.y",-1)
				elseif thatFiling.SubType == 2 then
					Set(MyFilingCabinet,"Or.x",-1)
					Set(MyFilingCabinet,"Or.y",0)
				elseif thatFiling.SubType == 3 then
					Set(MyFilingCabinet,"Or.x",1)
					Set(MyFilingCabinet,"Or.y",0)
				end

				thatFiling.Delete()
				Set(MyFilingCabinet,"HomeUID",this.HomeUID)
				Set(MyFilingCabinet,"Tooltip","HomeUID: "..this.HomeUID)
			end
		end
		myFiling = nil
	
		Set(MyCraneBooth,"FloorMade",true)
		Set(StreetManager,"UpdateRoadMap",true)
		
		this.Delete()
	end
end

function toggleMilitaryClicked()
	if this.IsMilitary == "No" then
		this.IsMilitary = "Yes"
	else
		this.IsMilitary = "No"
	end
	this.SetInterfaceCaption("toggleMilitary", "tooltip_Button_Military","tooltip_Button_IsMilitary_"..this.IsMilitary,"X")
	if Interface.SetComponentProperties ~= nil then
		Interface.SetComponentProperties( "MyMilitary", { Replacements = { M = "reportTooltip_Military"..this.IsMilitary } } )
	end
end

function CheckForOtherGarages()
	FindMapEdge()
    ConflictingY = 0
	local ConflictingSize = "normal"
	local CurrentDist = 9999
	local otherInstallers = Find("GantryCrane2Spawner",500)
	if next(otherInstallers) then
		for thatInstaller, dist in pairs(otherInstallers) do
			if thatInstaller.Id.i ~= this.Id.i then
				if Get(thatInstaller,"StartBuilding") == false then
					checker = Object.Spawn("FoundationChecker",this.Pos.x,this.OrigY)
					checker.SubType = 1
					checker.Tooltip = "Other installer found.\nSpecify its size and create the floor first.\nInstaller has been removed."
					this.Delete()
					return
				end
				--print("compare "..thatInstaller.OrigX.." with "..this.OrigX)
				if thatInstaller.OrigX == this.OrigX then
					OtherGarageAvailable = true
					if dist < CurrentDist then
						CurrentDist = dist
						ConflictingY = thatInstaller.OrigY
						ConflictingSize = thatInstaller.GarageSize
						--print("ConflictingY: "..ConflictingY)
					end
				end
			end
		end
	end
	local otherGarages = Find("GantryCrane2Hook",500)
	if next(otherGarages) then
		for thatGarage, dist in pairs(otherGarages) do
			--print("compare "..thatGarage.ParkX.." with "..this.OrigX)
			if thatGarage.ParkX == this.OrigX then
				OtherGarageAvailable = true
				if dist < CurrentDist then
					CurrentDist = dist
					ConflictingY = thatGarage.ParkY
					ConflictingSize = thatGarage.GarageSize
					--print("ConflictingY: "..ConflictingY)
				end
			end
		end
	end
				
	if ConflictingY > 0 then
		if ConflictingSize == "Normal" or ConflictingSize == "Wide" then
			if ConflictingY < this.OrigY and this.OrigY < ConflictingY+22 then
				print("Making adjacent to garage above me.")
				checker = Object.Spawn("FoundationChecker",this.Pos.x,this.OrigY)
				checker.SubType = 1
				checker.Tooltip = "Making adjacent to garage above me"
				Set(this,"OrigY",math.floor(ConflictingY+20))
				if this.MapBottom - this.OrigY < 24 then
					checker = Object.Spawn("FoundationChecker",this.Pos.x,this.OrigY)
					checker.SubType = 1
					checker.Tooltip = "Gantry crane can't be placed here.\nIt must be at least 24 tiles from map bottom.\nThe installer has been removed."
					this.Delete()
					return
				end
			end
			
			if ConflictingY > this.OrigY and ConflictingY-22 < this.OrigY then
				checker = Object.Spawn("FoundationChecker",this.Pos.x,this.OrigY)
				checker.SubType = 1
				checker.Tooltip = "The garage below me was nearer than 22 tiles, making adjacent.\nThe installer moved to the correct position."
				--print("The garage below me was nearer than 18 tiles, making adjacent.")
				Set(this,"OrigY",math.ceil(ConflictingY-20.5))
				Set(this,"TallNotPossible",true)
			end
			if ConflictingY > this.OrigY and ConflictingY-30 < this.OrigY then
				Set(this,"TallNotPossible",true)
				--print("c"..(ConflictingY-30).." y "..this.Pos.y)
			end
			if ConflictingY > this.OrigY and (ConflictingY-32 < this.OrigY and ConflictingY-29 > this.OrigY) then
				checker = Object.Spawn("FoundationChecker",this.Pos.x,this.OrigY)
				checker.SubType = 1
				checker.Tooltip = "The garage below me was between 29-32 tiles tiles, making adjacent for tall garage creation.\nThe installer moved to the correct position."
				--print("The garage below me was between 29-32 tiles tiles, making adjacent for tall garage creation.")
				Set(this,"OrigY",math.ceil(ConflictingY-30.5))
			
			end
			
		elseif ConflictingSize == "Tall" then
			if ConflictingY < this.OrigY and this.OrigY < ConflictingY+32 then
				checker = Object.Spawn("FoundationChecker",this.Pos.x,this.OrigY)
				checker.SubType = 1
				checker.Tooltip = "The garage above me was nearer than 32 tiles, making adjacent.\nThe installer moved to the correct position."
				--print("Garage above me was nearer than 32 tiles, making adjacent.")
				Set(this,"OrigY",math.floor(ConflictingY+30.5))
				if this.MapBottom - this.OrigY < 20 then
					checker = Object.Spawn("FoundationChecker",this.Pos.x,this.OrigY)
					checker.SubType = 1
					checker.Tooltip = "Gantry crane can't be placed here.\nIt must be at least 20 tiles from map bottom.\nThe installer has been removed."
					this.Delete()
					return
				end
			end
			
			if ConflictingY > this.OrigY and ConflictingY-22 < this.OrigY then
				checker = Object.Spawn("FoundationChecker",this.Pos.x,this.OrigY)
				checker.SubType = 1
				checker.Tooltip = "The garage below me was nearer than 22 tiles, making adjacent.\nThe installer moved to the correct position."
				--print("The garage below me was nearer than 22 tiles, making adjacent.")
				Set(this,"OrigY",math.ceil(ConflictingY-20.5))
				Set(this,"TallNotPossible",true)
			end
			if ConflictingY > this.OrigY and ConflictingY-30 < this.OrigY then
				Set(this,"TallNotPossible",true)
				--print("c"..(ConflictingY-30).." y "..this.Pos.y)
			end
			if ConflictingY > this.OrigY and (ConflictingY-32 < this.OrigY and ConflictingY-29 > this.OrigY) then
				checker = Object.Spawn("FoundationChecker",this.Pos.x,this.OrigY)
				checker.SubType = 1
				checker.Tooltip = "The garage below me was between 29-32 tiles tiles, making adjacent for tall garage creation.\nThe installer moved to the correct position."
				--print("The garage below me was between 29-32 tiles tiles, making adjacent for tall garage creation.")
				Set(this,"OrigY",math.ceil(ConflictingY-30.5))
			
			end
			
		end
		if this.Pos.y < 26 or this.MapBottom - this.OrigY < 24 then
			checker = Object.Spawn("FoundationChecker",this.Pos.x,this.OrigY)
			checker.SubType = 1
			checker.Tooltip = "Gantry crane can't be placed here.\nIt must be at least 25 tiles from map bottom for a normal or wide garage, or at least 35 tiles for a tall garage.\nThe installer was removed."
			this.Delete()
			return
		end
		if this.MapBottom - this.OrigY < 34 then
			Set(this,"TallNotPossible",true)
		end
	else
		if this.Pos.y < 26 then
			checker = Object.Spawn("FoundationChecker",this.Pos.x,this.OrigY)
			checker.SubType = 1
			checker.Tooltip = "Gantry crane can't be placed here.\nIt must be at least 26 tiles from map top.\nThe installer moved to the correct position."
			Set(this,"OrigY",26)
		end
		if this.MapBottom - this.OrigY < 24 then
			checker = Object.Spawn("FoundationChecker",this.Pos.x,this.OrigY)
			checker.SubType = 1
			checker.Tooltip = "Gantry crane can't be placed here.\nIt must be at least 24 tiles from map bottom for a normal or wide garage, or at least 35 tiles for a tall garage.\nThe installer moved to the correct position."
			Set(this,"OrigY",this.MapBottom-20)
		end
		if this.MapBottom - this.OrigY < 34 then
			Set(this,"TallNotPossible",true)
		end
	end
	otherInstallers = nil
	otherGarages = nil
end

function Update(timePassed)
	if not Get(this,"OrigXSet") then
		Set(this,"OrigX",math.floor(this.Pos.x))
		Set(this,"OrigY",math.floor(this.Pos.y)+6)
		Set(this,"OrigXSet",true)
	end
	if Get(this,"FromPrefab") == true then
		SetCoordinates()
	end
	this.Pos.x = this.OrigX
	this.Pos.y = this.OrigY
	if not Get(this,"TopOrBottomGarages") then
		CheckForOtherGarages()
		Set(this,"TopOrBottomGarages",true)
		return
	end
				
	timeAnim=timeAnim+timePassed
	if timeAnim > timePerAnim then
		timeAnim=0
		if this.SubType == 1 then this.SubType = 2 else this.SubType = 1 end
	end
				
	if this.TimeWarp == nil then
		CalculateTimeWarpFactor(timePassed)
		return
	elseif timePerUpdate == nil then
		timePerUpdate = 1 / myTimeWarpFactor
		if not Get(this,"FoundationDone") then
			if not ButtonStartBuildingPressed and Interface.SetReportTabs ~= nil then
				Interface.SetReportTabs( "reportTab_tab1")
			elseif Interface.SetReportTabs ~= nil then
				Interface.SetReportTabs( "reportTab_tab1","reportTab_tab2")
			end
			Interface.AddComponent(this,"Caption_GaragePlacement", "Caption", "tooltip_Caption_GaragePlacement")
			Interface.AddComponent(this,"toggleGaragePlacement", "Button", "tooltip_Button_GaragePlacement","tooltip_Button_"..this.GaragePlacement,"X")
			Interface.AddComponent(this,"Caption_GarageSize", "Caption", "tooltip_Caption_GarageSize")
			Interface.AddComponent(this,"toggleGarageSize", "Button", "tooltip_Button_GarageSize","tooltip_Button_"..this.GarageSize,"X")
			Interface.AddComponent(this,"Caption_PreviewGarage", "Caption", "tooltip_Caption_PreviewGarage")
			Interface.AddComponent(this,"toggleShowPreview", "Button", "tooltip_Button_ShowPreview")
			Interface.AddComponent(this,"Caption_BuildFloor", "Caption", "tooltip_Caption_BuildFloor")
			Interface.AddComponent(this,"toggleBuildFloor", "Button", "tooltip_Button_BuildFloor")
		else
			if Interface.SetReportTabs ~= nil then
				Interface.SetReportTabs( "reportTab_tab1","reportTab_tab2","reportTab_tab3","reportTab_tab4","reportTab_tab5")
			end
			Interface.AddComponent(this,"MakeRoad", "Button", "tooltip_Button_MakeRoad")
			Interface.AddComponent(this,"Caption_GarageSeparator1", "Caption", "tooltip_Caption_GarageSeparator")
			Interface.AddComponent(this,"toggleMilitary", "Button", "tooltip_Button_Military","tooltip_Button_IsMilitary_"..this.IsMilitary,"X")
			Interface.AddComponent(this,"Caption_GarageSeparator2", "Caption", "tooltip_Caption_GarageSeparator")
			Interface.AddComponent(this,"Caption_Inventory", "Caption", "tooltip_Caption_Inventory")
			Interface.AddComponent(this,"toggleScanInventory", "Button", "tooltip_Button_ScanInventory")
			Interface.AddComponent(this,"Caption_PlaceRepairSpots", "Caption", "tooltip_Caption_PlaceRepairSpots")
			Interface.AddComponent(this,"Caption_PlaceBooth", "Caption", "tooltip_Caption_PlaceBooth")
			Interface.AddComponent(this,"Caption_PlaceRack", "Caption", "tooltip_Caption_PlaceRack")
			Interface.AddComponent(this,"Caption_PlaceDesk", "Caption", "tooltip_Caption_PlaceDesk")
			Interface.AddComponent(this,"Caption_PlaceFiling", "Caption", "tooltip_Caption_PlaceFiling")
		end
	end
	
	timeTot=timeTot+timePassed
	if timeTot>=timePerUpdate then
		timeTot=0
		if this.StartBuilding == true then
			if not Get(this,"FoundationDone") then
				CreateFoundation()
				Interface.RemoveComponent(this,"Caption_GaragePlacement", "Caption", "tooltip_Caption_GaragePlacement")
				Interface.RemoveComponent(this,"toggleGaragePlacement", "Button", "tooltip_Button_GaragePlacement","tooltip_Button_"..this.GaragePlacement,"X")
				Interface.RemoveComponent(this,"Caption_GarageSize", "Caption", "tooltip_Caption_GarageSize")
				Interface.RemoveComponent(this,"toggleGarageSize", "Button", "tooltip_Button_GarageSize","tooltip_Button_"..this.GarageSize,"X")
				Interface.RemoveComponent(this,"Caption_PreviewGarage", "Caption", "tooltip_Caption_PreviewGarage")
				Interface.RemoveComponent(this,"toggleShowPreview", "Button", "tooltip_Button_ShowPreview")
				Interface.RemoveComponent(this,"Caption_BuildFloor", "Caption", "tooltip_Caption_BuildFloor")
				Interface.RemoveComponent(this,"toggleBuildFloor", "Button", "tooltip_Button_BuildFloor")
				
				Interface.AddComponent(this,"MakeRoad", "Button", "tooltip_Button_MakeRoad")
				Interface.AddComponent(this,"Caption_GarageSeparator1", "Caption", "tooltip_Caption_GarageSeparator")
				Interface.AddComponent(this,"toggleMilitary", "Button", "tooltip_Button_Military","tooltip_Button_IsMilitary_"..this.IsMilitary,"X")
				Interface.AddComponent(this,"Caption_GarageSeparator2", "Caption", "tooltip_Caption_GarageSeparator")
				Interface.AddComponent(this,"Caption_Inventory", "Caption", "tooltip_Caption_Inventory")
				Interface.AddComponent(this,"toggleScanInventory", "Button", "tooltip_Button_ScanInventory")
				Interface.AddComponent(this,"Caption_PlaceRepairSpots", "Caption", "tooltip_Caption_PlaceRepairSpots")
				Interface.AddComponent(this,"Caption_PlaceBooth", "Caption", "tooltip_Caption_PlaceBooth")
				Interface.AddComponent(this,"Caption_PlaceRack", "Caption", "tooltip_Caption_PlaceRack")
				Interface.AddComponent(this,"Caption_PlaceDesk", "Caption", "tooltip_Caption_PlaceDesk")
				Interface.AddComponent(this,"Caption_PlaceFiling", "Caption", "tooltip_Caption_PlaceFiling")
			end
		end
	end
end

function CreateFoundation()
	local U16 = false
	if Interface.SetReportTabs ~= nil then
		U16 = true
	end
	
	local x = math.floor(this.OrigX)
	local y = math.floor(this.OrigY)
	for i=math.floor(this.Ymin-1),math.ceil(this.Ymax+1) do	for j=this.Xmin-1,this.Xmax+1 do	local cell = World.GetCell(x+j,y+i);	cell.Mat = "BrickWall"; if U16 == true then cell.Ind = true end end	end
	for i=math.floor(this.Ymin),math.ceil(this.Ymax) do		for j=this.Xmin,this.Xmax do		local cell = World.GetCell(x+j,y+i);	cell.Mat = "ConcreteFloor"; if U16 == true then cell.Ind = true end end	end
	
	MakeRoadClicked()
	
	if previewShown == false then
		toggleShowPreviewClicked()
	end
	local Crane = Find(this,"GantryCrane2Preview",50)
	if next(Crane) then
		for thatCrane, dist in pairs(Crane) do
			if thatCrane.HomeUID == this.HomeUID then
				thatCrane.Delete()
			end
		end
	end
	if this.GaragePlacement == "Left" then
		newDoor = Object.Spawn("StaffDoor",this.OrigX-2.5,this.OrigY+this.Ymin-1)
		Set(newDoor,"HomeUID",this.HomeUID)
	else
		newDoor = Object.Spawn("StaffDoor",this.OrigX+2.5,this.OrigY+this.Ymin-1)
		Set(newDoor,"Or.y",-1)
		Set(newDoor,"OpenDir.x",1)
		Set(newDoor,"OpenDir.y",0)
		Set(newDoor,"HomeUID",this.HomeUID)
	end
	
	MyRepairedLimoGate = Object.Spawn("SmallRoadGate",this.OrigX,this.OrigY+this.Ymax-4.5)
	Set(MyRepairedLimoGate,"HomeUID",this.HomeUID)
	Set(MyRepairedLimoGate,"SmallPost",true)
	if this.GaragePlacement == "Left" then
		Set(MyRepairedLimoGate,"Or.y",-1)
		Set(MyRepairedLimoGate,"OpenDir.x",2)
		Set(MyRepairedLimoGate,"OpenDir.y",0)
		leftPart=Object.Spawn("RoadPoleEnd",MyRepairedLimoGate.Pos.x-1.5,MyRepairedLimoGate.Pos.y+0.5)
		rightPart=Object.Spawn("RoadPoleStart",MyRepairedLimoGate.Pos.x+2.5,MyRepairedLimoGate.Pos.y+0.5)
		MyRoadPole=Object.Spawn("SmallRoadPole",MyRepairedLimoGate.Pos.x+2,MyRepairedLimoGate.Pos.y)
		MyTrafficLightR = Object.Spawn("RoadPoleTrafficLight",MyRepairedLimoGate.Pos.x+2.5,MyRepairedLimoGate.Pos.y)
		Set(MyRoadPole,"SubType",1)
		Set(leftPart,"HomeUID",this.HomeUID)
		Set(leftPart,"Tooltip","HomeUID: "..this.HomeUID)
		Set(rightPart,"HomeUID",this.HomeUID)
		Set(rightPart,"Tooltip","HomeUID: "..this.HomeUID)
		Set(MyRoadPole,"HomeUID",this.HomeUID)
		Set(MyRoadPole,"Tooltip","HomeUID: "..this.HomeUID)
		Set(MyTrafficLightR,"HomeUID",this.HomeUID)
		Set(MyTrafficLightR,"Tooltip","HomeUID: "..this.HomeUID)
		Set(MyTrafficLightR,"SideLaneLight",true)
	else
		leftPart=Object.Spawn("RoadPoleStart",MyRepairedLimoGate.Pos.x-2.5,MyRepairedLimoGate.Pos.y+0.5)
		rightPart=Object.Spawn("RoadPoleEnd",MyRepairedLimoGate.Pos.x+1.5,MyRepairedLimoGate.Pos.y+0.5)
		rightPart.SubType = 1
		MyRoadPole=Object.Spawn("SmallRoadPole",MyRepairedLimoGate.Pos.x-2,MyRepairedLimoGate.Pos.y)
		MyTrafficLightL = Object.Spawn("RoadPoleTrafficLight",MyRepairedLimoGate.Pos.x-2.5,MyRepairedLimoGate.Pos.y)
		Set(leftPart,"HomeUID",this.HomeUID)
		Set(leftPart,"Tooltip","HomeUID: "..this.HomeUID)
		Set(rightPart,"HomeUID",this.HomeUID)
		Set(rightPart,"Tooltip","HomeUID: "..this.HomeUID)
		Set(MyRoadPole,"HomeUID",this.HomeUID)
		Set(MyRoadPole,"Tooltip","HomeUID: "..this.HomeUID)
		Set(MyTrafficLightL,"HomeUID",this.HomeUID)
		Set(MyTrafficLightL,"Tooltip","HomeUID: "..this.HomeUID)
		Set(MyTrafficLightL,"SideLaneLight",true)
	end
	Set(this,"FoundationDone",true)
end

function MakeRoadClicked()
	local U16 = false
	if Interface.SetReportTabs ~= nil then
		U16 = true
	end
	
	local x = math.floor(this.OrigX-1)
	local y = math.floor(this.OrigY+this.Ymin-1)
	local cell = World.GetCell(x-1,y)
	if this.GaragePlacement == "Left" then
		for i=0,math.floor((-this.Ymin))+math.ceil(this.Ymax+3) do
			cell = World.GetCell(x-1,y+i)	cell.Mat = "ConcreteTiles"; if U16 == true then cell.Ind = true end 
			cell = World.GetCell(x,y+i)		cell.Mat = "RoadMarkingsLeft"; if U16 == true then cell.Ind = true end 
			cell = World.GetCell(x+1,y+i)	cell.Mat = "RoadMarkingsRight"; if U16 == true then cell.Ind = true end 
			cell = World.GetCell(x+2,y+i)	cell.Mat = "RoadMarkingsLeft"; if U16 == true then cell.Ind = true end 
			cell = World.GetCell(x+3,y+i)	cell.Mat = "RoadMarkingsRight"; if U16 == true then cell.Ind = true end 
		end
		cell = World.GetCell(x+1,y+math.floor((-this.Ymin))-4)	cell.Mat = "innerdiagroadTR"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x+2,y+math.floor((-this.Ymin))-4)	cell.Mat = "diagsidewalkTR"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x+3,y+math.floor((-this.Ymin))-4)	cell.Mat = "ConcreteTiles"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x+1,y+math.floor((-this.Ymin))-3)	cell.Mat = "Road"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x+1,y+math.floor((-this.Ymin))-2)	cell.Mat = "Road"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x+2,y+math.floor((-this.Ymin))-2)	cell.Mat = "Road"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x+2,y+math.floor((-this.Ymin))-3)	cell.Mat = "innerdiagroadTR"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x+3,y+math.floor((-this.Ymin))-3)	cell.Mat = "diagsidewalkTR"; if U16 == true then cell.Ind = true end 
		
		cell = World.GetCell(x+1,y+math.ceil(this.Ymax))	cell.Mat = "Road"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x+2,y+math.ceil(this.Ymax))	cell.Mat = "Road"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x+1,y+math.ceil(this.Ymax+1))	cell.Mat = "Road"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x+2,y+math.ceil(this.Ymax+1))	cell.Mat = "innerdiagroadBR"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x+3,y+math.ceil(this.Ymax+1))	cell.Mat = "diagsidewalkBR"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x+1,y+math.ceil(this.Ymax+2))	cell.Mat = "innerdiagroadBR"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x+2,y+math.ceil(this.Ymax+2))	cell.Mat = "diagsidewalkBR"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x+3,y+math.ceil(this.Ymax+2))	cell.Mat = "ConcreteTiles"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x+2,y+math.ceil(this.Ymax+3))	cell.Mat = "ConcreteTiles"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x+3,y+math.ceil(this.Ymax+3))	cell.Mat = "ConcreteFloor"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x+2,y+math.ceil(this.Ymax+4))	cell.Mat = "ConcreteTiles"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x+3,y+math.ceil(this.Ymax+4))	cell.Mat = "ConcreteFloor"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x+2,y+math.ceil(this.Ymax+5))	cell.Mat = "ConcreteTiles"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x+3,y+math.ceil(this.Ymax+5))	cell.Mat = "ConcreteFloor"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x+2,y+math.ceil(this.Ymax+6))	cell.Mat = "ConcreteTiles"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x+3,y+math.ceil(this.Ymax+6))	cell.Mat = "ConcreteFloor"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x+2,y+math.ceil(this.Ymax+7))	cell.Mat = "ConcreteTiles"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x+3,y+math.ceil(this.Ymax+7))	cell.Mat = "ConcreteFloor"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x+3,y+math.ceil(this.Ymax+8))	cell.Mat = "BrickWall"; if U16 == true then cell.Ind = true end 
		
		cell = World.GetCell(x-3,y+math.floor((-this.Ymin))-5)	cell.Mat = "BrickWall"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x-1,y+math.floor((-this.Ymin))-5)	cell.Mat = "BrickWall"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x-2,y+math.floor((-this.Ymin))-5)	cell.Mat = "ConcreteTiles"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x+2,y+math.floor((-this.Ymin))-5)	cell.Mat = "BrickWall"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x+3,y+math.floor((-this.Ymin))-5)	cell.Mat = "BrickWall"; if U16 == true then cell.Ind = true end 
		
		
		cell = World.GetCell(x-3,y+math.ceil(this.Ymax+8))	cell.Mat = "BrickWall"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x-2,y+math.ceil(this.Ymax+8))	cell.Mat = "BrickWall"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x-1,y+math.ceil(this.Ymax+8))	cell.Mat = "BrickWall"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x+2,y+math.ceil(this.Ymax+8))	cell.Mat = "BrickWall"; if U16 == true then cell.Ind = true end 
	else
		for i=0,math.floor((-this.Ymin))+math.ceil(this.Ymax+3) do
			if this.GaragePlacement == "Centre" then cell = World.GetCell(x-3,y+i)	cell.Mat = "ConcreteTiles"; if U16 == true then cell.Ind = true end  end
			cell = World.GetCell(x-2,y+i)	cell.Mat = "RoadMarkingsLeft"; if U16 == true then cell.Ind = true end 
			cell = World.GetCell(x-1,y+i)	cell.Mat = "RoadMarkingsRight"; if U16 == true then cell.Ind = true end 
			cell = World.GetCell(x,y+i)	cell.Mat = "RoadMarkingsLeft"; if U16 == true then cell.Ind = true end 
			cell = World.GetCell(x+1,y+i)	cell.Mat = "RoadMarkingsRight"; if U16 == true then cell.Ind = true end 
			cell = World.GetCell(x+2,y+i)	cell.Mat = "ConcreteTiles"; if U16 == true then cell.Ind = true end 
		end
		cell = World.GetCell(x-2,y+math.floor((-this.Ymin))-4)	cell.Mat = "ConcreteTiles"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x-1,y+math.floor((-this.Ymin))-4)	cell.Mat = "diagsidewalkTL"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x,y+math.floor((-this.Ymin))-4)	cell.Mat = "innerdiagroadTL"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x-2,y+math.floor((-this.Ymin))-3)	cell.Mat = "diagsidewalkTL"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x-1,y+math.floor((-this.Ymin))-3)	cell.Mat = "innerdiagroadTL"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x,y+math.floor((-this.Ymin))-3)	cell.Mat = "Road"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x-1,y+math.floor((-this.Ymin))-2)	cell.Mat = "Road"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x,y+math.floor((-this.Ymin))-2)	cell.Mat = "Road"; if U16 == true then cell.Ind = true end 
		
		cell = World.GetCell(x-1,y+math.ceil(this.Ymax))	cell.Mat = "Road"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x,y+math.ceil(this.Ymax))		cell.Mat = "Road"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x,y+math.ceil(this.Ymax+1))	cell.Mat = "Road"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x-2,y+math.ceil(this.Ymax+1))	cell.Mat = "diagsidewalkBL"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x-1,y+math.ceil(this.Ymax+1))	cell.Mat = "innerdiagroadBL"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x-2,y+math.ceil(this.Ymax+2))	cell.Mat = "ConcreteTiles"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x-1,y+math.ceil(this.Ymax+2))	cell.Mat = "diagsidewalkBL"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x,y+math.ceil(this.Ymax+2))	cell.Mat = "innerdiagroadBL"; if U16 == true then cell.Ind = true end 
		if this.GaragePlacement == "Centre" then cell = World.GetCell(x-3,y+math.ceil(this.Ymax+3))	cell.Mat = "ConcreteFloor"; if U16 == true then cell.Ind = true end  end
		cell = World.GetCell(x-2,y+math.ceil(this.Ymax+3))	cell.Mat = "ConcreteFloor"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x-1,y+math.ceil(this.Ymax+3))	cell.Mat = "ConcreteTiles"; if U16 == true then cell.Ind = true end 
		if this.GaragePlacement == "Centre" then cell = World.GetCell(x-3,y+math.ceil(this.Ymax+4))	cell.Mat = "ConcreteFloor"; if U16 == true then cell.Ind = true end  end
		cell = World.GetCell(x-2,y+math.ceil(this.Ymax+4))	cell.Mat = "ConcreteFloor"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x-1,y+math.ceil(this.Ymax+4))	cell.Mat = "ConcreteTiles"; if U16 == true then cell.Ind = true end 
		if this.GaragePlacement == "Centre" then cell = World.GetCell(x-3,y+math.ceil(this.Ymax+5))	cell.Mat = "ConcreteFloor"; if U16 == true then cell.Ind = true end  end
		cell = World.GetCell(x-2,y+math.ceil(this.Ymax+5))	cell.Mat = "ConcreteFloor"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x-1,y+math.ceil(this.Ymax+5))	cell.Mat = "ConcreteTiles"; if U16 == true then cell.Ind = true end 
		if this.GaragePlacement == "Centre" then cell = World.GetCell(x-3,y+math.ceil(this.Ymax+6))	cell.Mat = "ConcreteFloor"; if U16 == true then cell.Ind = true end  end
		cell = World.GetCell(x-2,y+math.ceil(this.Ymax+6))	cell.Mat = "ConcreteFloor"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x-1,y+math.ceil(this.Ymax+6))	cell.Mat = "ConcreteTiles"; if U16 == true then cell.Ind = true end 
		if this.GaragePlacement == "Centre" then cell = World.GetCell(x-3,y+math.ceil(this.Ymax+7))	cell.Mat = "ConcreteFloor"; if U16 == true then cell.Ind = true end  end
		cell = World.GetCell(x-2,y+math.ceil(this.Ymax+7))	cell.Mat = "ConcreteFloor"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x-1,y+math.ceil(this.Ymax+7))	cell.Mat = "ConcreteTiles"; if U16 == true then cell.Ind = true end 
		
		cell = World.GetCell(x-3,y+math.floor((-this.Ymin))-5)	cell.Mat = "BrickWall"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x-1,y+math.floor((-this.Ymin))-5)	cell.Mat = "BrickWall"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x-2,y+math.floor((-this.Ymin))-5)	cell.Mat = "BrickWall"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x+2,y+math.floor((-this.Ymin))-5)	cell.Mat = "BrickWall"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x+3,y+math.floor((-this.Ymin))-5)	cell.Mat = "ConcreteTiles"; if U16 == true then cell.Ind = true end 
		
		cell = World.GetCell(x-3,y+math.ceil(this.Ymax+8))	cell.Mat = "BrickWall"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x-2,y+math.ceil(this.Ymax+8))	cell.Mat = "BrickWall"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x-1,y+math.ceil(this.Ymax+8))	cell.Mat = "BrickWall"; if U16 == true then cell.Ind = true end 
		cell = World.GetCell(x+2,y+math.ceil(this.Ymax+8))	cell.Mat = "BrickWall"; if U16 == true then cell.Ind = true end 
	end
end

function BuildGarage()
	MyCrane = Object.Spawn("GantryCrane2",this.OrigX+this.GantryCraneX,this.OrigY)
	if this.GaragePlacement ~= "Centre" then MyCrane.SubType = 1 end
	if this.GarageSize == "Wide" then MyCrane.SubType = 0 end
	Set(MyCrane,"HomeUID",this.HomeUID)
	Set(MyCrane,"TimeWarp",this.TimeWarp)
	Set(MyCrane,"GarageSize",GarageSize)
	Set(MyCrane,"GaragePlacement",GaragePlacement)
	Set(MyCrane,"CraneInPosition",false)
	Set(MyCrane,"MoveToCentre",false)
	Set(MyCrane,"MoveTheCrane",false)
	Set(MyCrane,"MoveToX",this.OrigX)
	Set(MyCrane,"MoveToY",this.OrigY)
	Set(MyCrane,"MoveLeftX",this.OrigX-1.5)
	Set(MyCrane,"MoveRightX",this.OrigX+1.5)
	Set(MyCrane,"TmpLeftX",this.OrigX)
	Set(MyCrane,"TmpRightX",this.OrigX)
	Set(MyCrane,"TmpY",this.OrigY)
	Set(MyCrane,"ParkX",this.OrigX)
	Set(MyCrane,"ParkY",this.OrigY)
	Set(MyCrane,"RoadX",this.OrigX)
	
	MyCraneRailRight = Object.Spawn("GantryCrane2RailRight",this.OrigX+this.RailRightX,this.OrigY+this.RailsY)
	if this.GarageSize == "Tall" then MyCraneRailRight.SubType = 1 end
	Set(MyCraneRailRight,"GarageSize",this.GarageSize)
	Set(MyCraneRailRight,"GaragePlacement",this.GaragePlacement)
	Set(MyCraneRailRight,"HomeUID",this.HomeUID)
	Set(MyCraneRailRight,"Tooltip","HomeUID: "..this.HomeUID)
	
	MyCraneRailLeft = Object.Spawn("GantryCrane2RailLeft",this.OrigX+this.RailLeftX,this.OrigY+this.RailsY)
	if this.GarageSize == "Tall" then MyCraneRailLeft.SubType = 1 end
	Set(MyCraneRailLeft,"GarageSize",this.GarageSize)
	Set(MyCraneRailLeft,"GaragePlacement",this.GaragePlacement)
	Set(MyCraneRailLeft,"HomeUID",this.HomeUID)
	Set(MyCraneRailLeft,"Tooltip","HomeUID: "..this.HomeUID)
	
	Set(MyCraneBooth,"IsMilitary",this.IsMilitary)
	Set(MyCraneBooth,"GarageSize",this.GarageSize)
	Set(MyCraneBooth,"GaragePlacement",this.GaragePlacement)
	Set(MyCraneBooth,"Xmin",this.Xmin)
	Set(MyCraneBooth,"Xmax",this.Xmax)
	Set(MyCraneBooth,"Ymin",this.Ymin)
	Set(MyCraneBooth,"Ymax",this.Ymax)
	Set(MyCraneBooth,"HomeUID",this.HomeUID)
	Set(MyCraneBooth,"FloorMade",false)
	Set(MyCraneBooth,"GarageIsFull",false)
	Set(MyCraneBooth,"PartsRackIsFull",false)
	Set(MyCraneBooth,"BusyDoingJob",false)
	Set(MyCraneBooth,"ParkX",this.OrigX)
	Set(MyCraneBooth,"ParkY",this.OrigY)
	if this.GaragePlacement == "Left" then
		Set(MyCraneBooth,"TruckParkX",this.OrigX+2)
		Set(MyCraneBooth,"TruckParkY",this.OrigY+1)
	else
		Set(MyCraneBooth,"TruckParkX",this.OrigX-2)
		Set(MyCraneBooth,"TruckParkY",this.OrigY+1)
	end
	Set(MyCraneBooth,"RoadX",this.OrigX)
	Set(MyCraneBooth,"RoadY",this.OrigY+this.Ymax-2)
	Set(MyCraneBooth,"OrderLimoAmount",0)
	Set(MyCraneBooth,"OrderPartsAmount",0)
	
	Set(MyCraneBooth,"UnloadTruckSlot0",false)
	Set(MyCraneBooth,"UnloadTruckSlot1",false)
	
	Set(MyCraneBooth,"UnloadEngineSlot0",false)
	Set(MyCraneBooth,"UnloadEngineSlot1",false)
	
	Set(MyCraneBooth,"UnloadSlot0",false)
	Set(MyCraneBooth,"UnloadSlot1",false)
	Set(MyCraneBooth,"UnloadSlot2",false)
	Set(MyCraneBooth,"UnloadSlot3",false)
	Set(MyCraneBooth,"UnloadSlot4",false)
	Set(MyCraneBooth,"UnloadSlot5",false)
	Set(MyCraneBooth,"UnloadSlot6",false)
	Set(MyCraneBooth,"UnloadSlot7",false)
	Set(MyCraneBooth,"UnloadSlot8",false)
	Set(MyCraneBooth,"UnloadSlot9",false)
	Set(MyCraneBooth,"UnloadSlot10",false)
	Set(MyCraneBooth,"UnloadSlot11",false)
	Set(MyCraneBooth,"UnloadSlot12",false)
	Set(MyCraneBooth,"UnloadSlot13",false)
	Set(MyCraneBooth,"UnloadSlot14",false)
	Set(MyCraneBooth,"UnloadSlot15",false)
	
	Set(MyCraneBooth,"BringEngine0",false)
	Set(MyCraneBooth,"BringEngine1",false)
	Set(MyCraneBooth,"BringEngine2",false)
	Set(MyCraneBooth,"BringEngine3",false)
	Set(MyCraneBooth,"BringEngine4",false)
	Set(MyCraneBooth,"BringEngine5",false)
	Set(MyCraneBooth,"BringEngine6",false)
	Set(MyCraneBooth,"BringEngine7",false)
	Set(MyCraneBooth,"BringEngine8",false)
	Set(MyCraneBooth,"BringEngine9",false)
	Set(MyCraneBooth,"BringEngine10",false)
	Set(MyCraneBooth,"BringEngine11",false)
	Set(MyCraneBooth,"BringEngine12",false)
	Set(MyCraneBooth,"BringEngine13",false)
	Set(MyCraneBooth,"BringEngine14",false)
	Set(MyCraneBooth,"BringEngine15",false)
	
	Set(MyCraneBooth,"BringToRack0",false)
	Set(MyCraneBooth,"BringToRack1",false)
	Set(MyCraneBooth,"BringToRack2",false)
	Set(MyCraneBooth,"BringToRack3",false)
	Set(MyCraneBooth,"BringToRack4",false)
	Set(MyCraneBooth,"BringToRack5",false)
	Set(MyCraneBooth,"BringToRack6",false)
	Set(MyCraneBooth,"BringToRack7",false)
	Set(MyCraneBooth,"BringToRack8",false)
	
	Set(MyCraneBooth,"PutEngineInLessonCar1",false)
	Set(MyCraneBooth,"PutEngineInLessonCar2",false)
	Set(MyCraneBooth,"PutEngineInLessonCar3",false)
	Set(MyCraneBooth,"PutEngineInLessonCar4",false)
	Set(MyCraneBooth,"PutEngineInLessonCar5",false)
	Set(MyCraneBooth,"PutEngineInLessonCar6",false)
	Set(MyCraneBooth,"PutEngineInLessonCar7",false)
	Set(MyCraneBooth,"PutEngineInLessonCar8",false)
	Set(MyCraneBooth,"PutEngineInLessonCar9",false)
	Set(MyCraneBooth,"PutEngineInLessonCar10",false)
	
	Set(MyCraneBooth,"ScanForLimoOnRoad",false)
	Set(MyCraneBooth,"GateCount",0)
	Set(MyCraneBooth,"BusyDoingJob",false)
	Set(MyCraneBooth,"LimoWaitingOnRoad",false)
	Set(MyCraneBooth,"TimeToOrderLimoTruck",0)
	Set(MyCraneBooth,"TimeToOrderPartsTruck",0)
	Set(MyCraneBooth,"TruckTimerLimo",15+math.random()+math.random()+math.random()+math.random()+math.random()+math.random()+math.random())
	Set(MyCraneBooth,"TruckTimerParts",35+math.random()+math.random()+math.random()+math.random()+math.random()+math.random()+math.random())
	Set(MyCraneBooth,"CurrentTask","tooltip_CraneIdle")
	
	MyHook = Object.Spawn("GantryCrane2Hook",this.OrigX,this.OrigY)
	Set(MyHook,"GarageSize",this.GarageSize)
	Set(MyHook,"GaragePlacement",this.GaragePlacement)
	Set(MyHook,"HomeUID",this.HomeUID)
	Set(MyHook,"TimeWarp",this.TimeWarp)
	Set(MyHook,"ParkX",this.OrigX)
	Set(MyHook,"ParkY",this.OrigY)
	Set(MyHook,"RoadX",this.OrigX)
	
	MyCraneWheelLeft = Object.Spawn("GantryCrane2Wheel",this.OrigX+this.RailLeftX,this.OrigY-0.25)
	Set(MyCraneWheelLeft,"HomeUID",this.HomeUID)
	Set(MyCraneWheelLeft,"Tooltip","HomeUID: "..this.HomeUID)
	
	MyCraneWheelRight = Object.Spawn("GantryCrane2Wheel",this.OrigX+this.RailRightX,this.OrigY-0.25)
	Set(MyCraneWheelRight,"HomeUID",this.HomeUID)
	Set(MyCraneWheelRight,"Tooltip","HomeUID: "..this.HomeUID)
	
	Set(MyCrane,"Slot0.i",MyCraneWheelLeft.Id.i)
	Set(MyCrane,"Slot0.u",MyCraneWheelLeft.Id.u)
	Set(MyCrane,"Slot1.i",MyCraneWheelRight.Id.i)
	Set(MyCrane,"Slot1.u",MyCraneWheelRight.Id.u)
	MyCraneRailLeft.Loaded = true
	MyCraneWheelRight.Loaded = true
	
	local TopgatePresent = false
	smallRoadGates = Find("SmallRoadGate",50)
	if next(smallRoadGates) then
		for thatGate, dist in pairs(smallRoadGates) do
			if thatGate.Pos.x == this.OrigX and thatGate.Pos.y == this.OrigY+this.Ymin-1 then
				MyTopGate = thatGate
				Set(MyTopGate,"HomeUID",this.HomeUID)
				TopgatePresent = true
				break
			end
		end
	end
	smallRoadGates = nil
	
	if TopgatePresent == false then
		MyTopGate = Object.Spawn("SmallRoadGate",this.OrigX,this.OrigY+this.Ymin-1)
		Set(MyTopGate,"HomeUID",this.HomeUID)
		if this.GaragePlacement == "Left" then
			Set(MyTopGate,"Or.y",-1)
			Set(MyTopGate,"OpenDir.x",2)
			Set(MyTopGate,"OpenDir.y",0)
		end
	end
	
	
	local BottomgatePresent = false
	smallRoadGates = Find("SmallRoadGate",50)
	if next(smallRoadGates) then
		for thatGate, dist in pairs(smallRoadGates) do
			if thatGate.Pos.x == this.OrigX and thatGate.Pos.y == this.OrigY+this.Ymax+2 then
				MyBottomGate = thatGate
				Set(MyBottomGate,"HomeUID",this.HomeUID)
				BottomgatePresent = true
				break
			end
		end
	end
	
	if BottomgatePresent == false then
		MyBottomGate = Object.Spawn("SmallRoadGate",this.OrigX,this.OrigY+this.Ymax+2)
		Set(MyBottomGate,"HomeUID",this.HomeUID)
		if this.GaragePlacement == "Left" then
			Set(MyBottomGate,"Or.y",-1)
			Set(MyBottomGate,"OpenDir.x",2)
			Set(MyBottomGate,"OpenDir.y",0)
		end
	end
	
	Set(MyHook,"RoadY",this.OrigY+this.Ymax-2)
	DeleteMyRoadMarker()
	RoadMarker = Object.Spawn("RoadMarker",this.OrigX,0.5000000)
	Set(RoadMarker,"MarkerUID",me["id-uniqueId"])
	if OtherGarageAvailable == false then
		Set(RoadMarker,"BuildRoad",true)
	end
	Set(RoadMarker,"Sub",1)
	Set(RoadMarker,"SubType",8)
	--Set(RoadMarker,"GarageTraffic","yes")
	
	Set(MyCraneBooth,"MarkerUID",RoadMarker.MarkerUID)
	Set(MyCraneRailLeft,"MarkerUID",RoadMarker.MarkerUID)
	Set(MyCraneRailRight,"MarkerUID",RoadMarker.MarkerUID)
	Set(MyHook,"MarkerUID",RoadMarker.MarkerUID)
	
	Set(this,"GarageMade",true)
end

function MakeCarSpotsFloor(theX,theY)
	local U16 = false
	if Interface.SetReportTabs ~= nil then
		U16 = true
	end
	
	local x = math.floor(theX)
	local y = math.floor(theY)
	local cell = World.GetCell(x,y)	cell.Mat = "MetalFloor"; if U16 == true then cell.Ind = true end 
	cell = World.GetCell(x+1,y+1)	cell.Mat = "MetalFloor"; if U16 == true then cell.Ind = true end 
	cell = World.GetCell(x+1,y+2)	cell.Mat = "MetalFloor"; if U16 == true then cell.Ind = true end 
	cell = World.GetCell(x+1,y+3)	cell.Mat = "MetalFloor"; if U16 == true then cell.Ind = true end 
	cell = World.GetCell(x+1,y)	cell.Mat = "MetalFloor"; if U16 == true then cell.Ind = true end 
	cell = World.GetCell(x,y+1)	cell.Mat = "MetalFloor"; if U16 == true then cell.Ind = true end 
	cell = World.GetCell(x,y+2)	cell.Mat = "MetalFloor"; if U16 == true then cell.Ind = true end 
	cell = World.GetCell(x,y+3)	cell.Mat = "MetalFloor"; if U16 == true then cell.Ind = true end 
end

function MakeLessonCarFloor(theX,theY)
	local U16 = false
	if Interface.SetReportTabs ~= nil then
		U16 = true
	end
	
	local x = math.floor(theX)
	local y = math.floor(theY)
	local cell = World.GetCell(x,y)	cell.Mat = "MetalFloor"; if U16 == true then cell.Ind = true end 
	cell = World.GetCell(x+1,y+1)	cell.Mat = "MetalFloor"; if U16 == true then cell.Ind = true end 
	cell = World.GetCell(x+1,y)	cell.Mat = "MetalFloor"; if U16 == true then cell.Ind = true end 
	cell = World.GetCell(x,y+1)	cell.Mat = "MetalFloor"; if U16 == true then cell.Ind = true end 
end







function CalculateTimeWarpFactor(timePassed)
	if timeInit > initTimer then
	
		if timePerUpdate == nil then
			Now = math.floor(math.mod(World.TimeIndex,60))
			if not StartCountdown then
				if Now ~= StartingMinute then
				--	this.SubType = 3
					StartingMinute = Now
					if Now < 59 then
						EndingMinute = Now + 1				-- calculate TimeWarp within the next minute
						StartCountdown = true
					else
						return				-- wait another minute if object is placed 1 minute before next whole hour
					end
				end
			else
				timeTot=timeTot+timePassed
				this.Tooltip = {"tooltip_Init_TimeWarpB",StartingMinute,"A",EndingMinute,"B",Now,"C",timeTot,"D" }
				
				if Now >= StartingMinute+1 then
					if timeTot >= 5.4 then			-- the result should be around 8 (1/8) for large map with slow time enabled, compare with 5.4 to compensate for lag
						myTimeWarpFactor = 0.125
					--	this.SubType = 4
						myMapSize = "LARGE"
						mySlowTime = "YES"
						timeWarpFound = true
					elseif timeTot >= 4.1 then		-- the result should be around 5.33 (3/16) for medium map with slow time enabled
						myTimeWarpFactor = 0.1875
					--	this.SubType = 5
						myMapSize = "MEDIUM"
						mySlowTime = "YES"
						timeWarpFound = true
					elseif timeTot >= 2.1 then		-- the result should be around 4 (1/4) for small map with slow time enabled
						myTimeWarpFactor = 0.25
					--	this.SubType = 6
						myMapSize = "SMALL"
						mySlowTime = "YES"
						timeWarpFound = true
					elseif timeTot >= 1.4 then		-- the result should be around 2 (1/2) for large map
						myTimeWarpFactor = 0.5
					--	this.SubType = 7
						myMapSize = "LARGE"
						mySlowTime = "NO"
						timeWarpFound = true
					elseif timeTot >= 1.1 then		-- the result should be around 1.33 (3/4) for medium map
						myTimeWarpFactor = 0.75
					--	this.SubType = 8
						myMapSize = "MEDIUM"
						mySlowTime = "NO"
						timeWarpFound = true
					else							-- the result should be around 1 (1) for small map
						myTimeWarpFactor = 1
					--	this.SubType = 9
						myMapSize = "SMALL"
						mySlowTime = "NO"
						timeWarpFound = true
					end
					
					-- Instead of using the hard coded TimeWarp values (found in de saved game and mentioned above),
					-- you could also calculate your own by dividing 1 minute by the time it took to get to that minute.
					-- The result will be approximately the hard coded TimeWarp value, but can be different for each object you place,
					-- depending on how busy the game is, this is should not be used by default:
					
					--timeWarpFound = false					-- enable to see this calculation result in action
					--if timeWarpFound == false then myTimeWarpFactor = 1 / timeTot end
					
					this.Tooltip = {"tooltip_Init_TimeWarpC",StartingMinute,"A",EndingMinute,"B",Now,"C",timeTot,"D",myMapSize,"E",myTimeWarpFactor,"F",mySlowTime,"G" }	-- show results
					
					-- set the timePerUpdate here so we get out of this function
					timePerUpdate = 1 / myTimeWarpFactor	-- will show the results for 3 game minutes
				end
			end
		else		-- calculation completed, so save the results
			timeTot = timeTot+timePassed
			if timeTot > timePerUpdate then
			--	this.SubType = 0						-- change sprite back to normal
				Set(this,"TimeWarp",myTimeWarpFactor)	-- this tells function Update() to proceed
				this.Tooltip = "tooltip_ReadyForAction"
				timePerUpdate = nil				-- reset to nil so function Update() can proceed with normal activity
			end
		end
	else
		timeInit = timeInit+timePassed
		StartingMinute = math.floor(math.mod(World.TimeIndex,60))
	end
end


function SetTabNames()
	if this.StartBuilding == false then
		Interface.SetReportTabs( "reportTab_tab1")
	else
		Interface.SetReportTabs( "reportTab_tab1","reportTab_tab2","reportTab_tab3","reportTab_tab4","reportTab_tab5")
	end
end


function PopulateReport( tabIndex )
	tabIndex = tonumber( tabIndex)
    local w, h = Interface.GetReportWindowSize()
	if w == nil	or h == nil then return end
	
    w = w - 20  -- Top level canvas scrollbar
    
    local rowHeight = math.min(w, h) / 25.0
    local rowGap = rowHeight * 2
    local y = 0
    
    -- Title
    Interface.AddReportComponent( 
        {
            Type = "Title", 
            Caption = "reportTitle_GarageInstaller"
        }
    )
			
    if tabIndex == 1 then
		
		if this.TimeWarp == nil then
			
			Interface.AddReportComponent( 
				{
					Type = "Caption", 
					X = 0, 
					Y = y, 
					W = w, 
					H = rowHeight * 1.25, 
					Caption = "reportTooltip_CaptionTimeWarp",
					Centred = true
				}
			)
			y = y + rowGap
			
			Interface.AddReportComponent( 
				{
					Type = "Image", 
					Name = "ImgOverview", 
					X = (w / 2) - (w / 4),
					Y = y, 
					W = w / 2, 
					H = w / 2, 
					File = "report_overview.png", 
					Colour = "White"
				}
			)
			y = y + ( w / 2 ) - rowHeight + rowGap
			
			Interface.AddReportComponent( 
				{
					Type = "MultiLineText",
					Name = "TimeWarp",
					X = 0, 
					Y = y, 
					W = w, 
					H = rowHeight * 15, 
					LineSize = rowHeight, 
					Caption = "reportTooltip_TimeWarp"
				}
			)
		else
			if this.StartBuilding == false then
				Interface.AddReportComponent( 
					{
						Type = "Caption", 
						X = 0, 
						Y = y, 
						W = w, 
						H = rowHeight * 1.25, 
						Caption = "reportTooltip_CaptionOverview",
						Centred = true
					}
				)
				y = y + rowGap
					
				Interface.AddReportComponent( 
					{
						Type = "Image", 
						Name = "ImgOverview", 
						X = (w / 2) - (w / 4),
						Y = y, 
						W = w / 2, 
						H = w / 2, 
						File = "report_overview.png", 
						Colour = "White"
					}
				)
				y = y + ( w / 2 ) - rowHeight + rowGap
				
				Interface.AddReportComponent( 
					{
						Type = "MultiLineText", 
						Name = "Overview",
						X = 0, 
						Y = y, 
						W = w, 
						H = rowHeight * 5, 
						LineSize = rowHeight, 
						Caption = "reportTooltip_Overview"
					}
				)
				y = y + (rowHeight * 4) + rowGap
				
				Interface.AddReportComponent( 
					{
						Type = "Button", 
						Name = "StartBuilding",
						X = w / 4, 
						Y = y, 
						W = w / 2, 
						H = rowHeight * 2, 
						LineSize = rowHeight, 
						Caption = "reportButton_StartBuilding"
					}
				)
				y = y + rowHeight + rowGap
				
				Interface.AddReportComponent( 
					{
						Type = "Button", 
						Name = "CancelBuilding",
						X = w / 4, 
						Y = y, 
						W = w / 2, 
						H = rowHeight, 
						LineSize = rowHeight, 
						Caption = "reportButton_CancelBuilding"
					}
				)
			else
				Interface.AddReportComponent( 
					{
						Type = "Caption", 
						X = 0, 
						Y = y, 
						W = w, 
						H = rowHeight * 1.25, 
						Caption = "reportTooltip_CaptionFoundationDone",
						Centred = true
					}
				)
				y = y + rowGap
				
				Interface.AddReportComponent( 
					{
						Type = "Image", 
						Name = "ImgOverview", 
						X = (w / 2) - (w / 4),
						Y = y, 
						W = w / 2, 
						H = w / 2, 
						File = "report_overview.png", 
						Colour = "White"
					}
				)
				y = y + ( w / 2 ) - rowHeight + rowGap
				
				Interface.AddReportComponent( 
					{
						Type = "MultiLineText", 
						Name = "FloorDone",
						X = 0, 
						Y = y, 
						W = w, 
						H = rowHeight * 3, 
						LineSize = rowHeight, 
						Caption = "reportTooltip_FoundationDone"
					}
				)
				y = y + (rowHeight * 2) + rowGap
				
				Interface.AddReportComponent( 
					{
						Type = "MultiLineText", 
						Name = "FloorDone1",
						X = (w / 2) - (w / 4), 
						Y = y, 
						W = w / 3, 
						H = rowHeight * 5, 
						LineSize = rowHeight, 
						Caption = "reportTooltip_FoundationDone1"
					}
				)
				
				Interface.AddReportComponent( 
					{
						Type = "MultiLineText", 
						Name = "FloorDone2",
						X = (w / 3) + (w / 3), 
						Y = y, 
						W = w / 3, 
						H = rowHeight * 5, 
						LineSize = rowHeight, 
						Caption = "reportTooltip_FoundationDone2",
						Replacements = { A = InventoryRepairSpots, B = InventoryPartsRack, C = InventoryControl, D = InventoryServiceDesk, E = InventoryCabinet }
					}
				)
				
				y = y + (rowHeight * 4) + rowGap
				
				Interface.AddReportComponent( 
					{
						Type = "Button", 
						Name = "CheckObjects",
						X = w / 4, 
						Y = y, 
						W = w / 2, 
						H = rowHeight * 1.25, 
						LineSize = rowHeight, 
						Caption = "reportButton_CheckObjects"
					}
				)
				y = y + rowHeight + rowGap
				Interface.AddReportComponent( 
					{
						Type = "MultiLineText", 
						Name = "Objects",
						X = 0, 
						Y = y, 
						W = w, 
						H = rowHeight * 2, 
						LineSize = rowHeight, 
						Caption = "reportTooltip_FoundationDoneTips"
					}
				)
			end
		end
    end
	
    if tabIndex == 2 then
		if this.StartBuilding == false then
			Interface.AddReportComponent( 
				{
					Type = "Image", 
					Name = "ImgGarageSizes", 
					X = 0,
					Y = y, 
					W = w, 
					H = w / 2, 
					File = "report_garagesizes.png", 
					Colour = "White"
				}
			)
			y = y + ( w / 2 ) - rowHeight + rowGap
			
			Interface.AddReportComponent( 
				{
					Type = "MultiLineText", 
					Name = "Placement",
					X = 0, 
					Y = y, 
					W = w, 
					H = rowHeight * 3, 
					LineSize = rowHeight, 
					Caption = "reportTooltip_Placement"
				}
			)
			y = y + (rowHeight) + rowGap
			
			Interface.AddReportComponent( 
				{
					Type = "Caption", 
					Name = "MyPlacement",
					X = 0, 
					Y = y, 
					W = w / 2, 
					H = rowHeight, 
					Caption = "reportTooltip_GaragePlacement",
					Replacements = { R = "reportTooltip_PlacementCentre" }
				}
			)
			
			Interface.AddReportComponent( 
				{
					Type = "Button", 
					Name = "GaragePlacement",
					X = (w / 3) + (w / 3),
					Y = y, 
					W = w / 3, 
					H = rowHeight, 
					LineSize = rowHeight, 
					Caption = "reportButton_GaragePlacement"
				}
			)
			y = y + rowGap
			
			Interface.AddReportComponent( 
				{
					Type = "Caption", 
					Name = "MySize",
					X = 0, 
					Y = y, 
					W = w, 
					H = rowHeight, 
					Caption = "reportTooltip_GarageSize",
					Replacements = { S = "reportTooltip_SizeNormal" }
				}
			)
			Interface.AddReportComponent( 
				{
					Type = "Button", 
					Name = "GarageSize",
					X = (w / 3) + (w / 3),
					Y = y, 
					W = w / 3, 
					H = rowHeight, 
					LineSize = rowHeight, 
					Caption = "reportButton_GarageSize"
				}
			)
			y = y + rowGap
			
			Interface.AddReportComponent( 
				{
					Type = "Caption", 
					Name = "MyMilitary",
					X = 0, 
					Y = y, 
					W = w, 
					H = rowHeight, 
					Caption = "reportTooltip_GarageMilitary",
					Replacements = { M = "reportTooltip_MilitaryNo" }
				}
			)
			Interface.AddReportComponent( 
				{
					Type = "Button", 
					Name = "GarageMilitary",
					X = (w / 3) + (w / 3),
					Y = y, 
					W = w / 3, 
					H = rowHeight, 
					LineSize = rowHeight, 
					Caption = "reportButton_GarageMilitary"
				}
			)
			y = y + rowGap
			
			Interface.AddReportComponent( 
				{
					Type = "MultiLineText", 
					Name = "Preview",
					X = 0, 
					Y = y, 
					W = w, 
					H = rowHeight * 3, 
					LineSize = rowHeight, 
					Caption = "reportTooltip_ShowHidePreview"
				}
			)
			y = y + rowHeight + rowGap
			
			Interface.AddReportComponent( 
				{
					Type = "Button", 
					Name = "ShowHidePreview",
					X = w / 4,
					Y = y, 
					W = w / 2, 
					H = rowHeight, 
					LineSize = rowHeight, 
					Caption = "reportButton_ShowHidePreview"
				}
			)
			y = y + rowGap
			
			Interface.AddReportComponent( 
				{
					Type = "Caption", 
					Name = "MakeFloor",
					X = 0, 
					Y = y, 
					W = w, 
					H = rowHeight,
					Centred = true,
					Caption = "reportTooltip_BuildFloor"
				}
			)
			y = y + rowGap
			
			Interface.AddReportComponent( 
				{
					Type = "Button", 
					Name = "BuildFloor",
					X = w / 4,
					Y = y, 
					W = w / 2, 
					H = rowHeight, 
					LineSize = rowHeight, 
					Caption = "reportButton_BuildFloor"
				}
			)
		else
			Interface.AddReportComponent(
				{
					Type = "Caption", 
					X = 0, 
					Y = y, 
					W = w, 
					H = rowHeight * 1.25, 
					Caption = "reportTooltip_CaptionTips",
					Centred = true
				}
			)
			y = y + rowGap
			
			Interface.AddReportComponent(
				{
					Type = "MultiLineText", 
					Name = "AdjacentGarage",
					X = 0, 
					Y = y, 
					W = w, 
					H = rowHeight * 4, 
					LineSize = rowHeight, 
					Caption = "reportTooltip_TipsAdjacent"
				}
			)
			y = y + (rowHeight * 3) + rowGap
			Interface.AddReportComponent( 
				{
					Type = "Image", 
					Name = "ImgAdjacentGarage",
					X = (w / 2) - (w / 4),
					Y = y, 
					W = w / 2, 
					H = w / 4, 
					File = "report_adjacentgarage.png", 
					Colour = "White"
				}
			)
			y = y + ( w / 4 ) - rowHeight + rowGap
			
			
			Interface.AddReportComponent(
				{
					Type = "MultiLineText", 
					Name = "PathGarage",
					X = 0, 
					Y = y, 
					W = w, 
					H = rowHeight * 4, 
					LineSize = rowHeight, 
					Caption = "reportTooltip_TipsPath"
				}
			)
			y = y + (rowHeight * 3) + rowGap
			Interface.AddReportComponent( 
				{
					Type = "Image", 
					Name = "ImgPathGarage",
					X = (w / 2) - (w / 4),
					Y = y, 
					W = w / 2, 
					H = w / 4, 
					File = "report_pathgarage.png", 
					Colour = "White"
				}
			)
			y = y + ( w / 4 ) - rowHeight + rowGap
			
			Interface.AddReportComponent(
				{
					Type = "MultiLineText", 
					Name = "MaxGarage",
					X = 0, 
					Y = y, 
					W = w, 
					H = rowHeight * 5, 
					LineSize = rowHeight, 
					Caption = "reportTooltip_TipsMaxGarage"
				}
			)
		end
    end
    if tabIndex == 3 then
		Interface.AddReportComponent( 
			{
				Type = "Caption", 
				X = 0, 
				Y = y, 
				W = w, 
				H = rowHeight * 1.25, 
				Caption = "reportTooltip_CaptionObjects",
				Centred = true
			}
		)
		y = y + rowGap
		
		Interface.AddReportComponent( 
			{
				Type = "Image", 
				Name = "ImgObjects", 
				X = 0,
				Y = y, 
				W = w / 2, 
				H = w / 2, 
				File = "report_wall.png", 
				Colour = "White"
			}
		)
		Interface.AddReportComponent( 
			{
				Type = "Image", 
				Name = "ImgObjects2", 
				X = (w / 2),
				Y = y, 
				W = w / 2, 
				H = w / 2, 
				File = "report_objects.png", 
				Colour = "White"
			}
		)
		
		y = y + ( w / 2 ) - rowHeight + rowGap
		
		Interface.AddReportComponent( 
			{
				Type = "MultiLineText", 
				Name = "Objects",
				X = 0, 
				Y = y, 
				W = w, 
				H = rowHeight * 12, 
				LineSize = rowHeight, 
				Caption = "reportTooltip_Objects"
			}
		)
		y = y + (rowHeight * 11) + rowGap
		
		Interface.AddReportComponent( 
			{
				Type = "Button", 
				Name = "CheckObjects",
				X = w / 4, 
				Y = y, 
				W = w / 2, 
				H = rowHeight * 1.25, 
				LineSize = rowHeight, 
				Caption = "reportButton_CheckObjects"
			}
		)
	end
    if tabIndex == 4 then
		Interface.AddReportComponent( 
			{
				Type = "Caption", 
				X = 0, 
				Y = y, 
				W = w, 
				H = rowHeight * 1.25, 
				Caption = "reportTooltip_CaptionDeployment",
				Centred = true
			}
		)
		y = y + rowGap
		
		Interface.AddReportComponent( 
			{
				Type = "Image", 
				Name = "ImgObjects1", 
				X = 0,
				Y = y, 
				W = w / 2, 
				H = w / 2, 
				File = "report_deployment1.png", 
				Colour = "White"
			}
		)
		
		Interface.AddReportComponent( 
			{
				Type = "Image", 
				Name = "ImgObjects2", 
				X = (w / 2),
				Y = y, 
				W = w / 2, 
				H = w / 2, 
				File = "report_deployment2.png", 
				Colour = "White"
			}
		)
		y = y + ( w / 2 ) + rowGap
		
		Interface.AddReportComponent( 
			{
				Type = "MultiLineText", 
				Name = "Deployment1",
				X = 0, 
				Y = y, 
				W = w, 
				H = rowHeight * 14, 
				LineSize = rowHeight, 
				Caption = "reportTooltip_Deployment"
			}
		)
	end
    if tabIndex == 5 then
		Interface.AddReportComponent( 
			{
				Type = "Caption", 
				X = 0, 
				Y = y, 
				W = w, 
				H = rowHeight * 1.25, 
				Caption = "reportTooltip_CaptionLogistics",
				Centred = true
			}
		)
		y = y + rowGap
		
		Interface.AddReportComponent( 
			{
				Type = "Image", 
				Name = "ImgObjects", 
				X = (w / 2) - (w / 4),
				Y = y, 
				W = w / 2, 
				H = w / 2, 
				File = "report_work.png", 
				Colour = "White"
			}
		)
		y = y + ( w / 2 ) + rowGap
		
		Interface.AddReportComponent( 
			{
				Type = "MultiLineText", 
				Name = "Logistics",
				X = 0, 
				Y = y, 
				W = w, 
				H = rowHeight * 14, 
				LineSize = rowHeight, 
				Caption = "reportTooltip_Logistics"
			}
		)
	end
end

function ButtonPressed_StartBuilding()
    Interface.SetReportTabs( "reportTab_tab1","reportTab_tab2")
	ButtonStartBuildingPressed = true
end

function ButtonPressed_CancelBuilding()
	this.Delete()
end

function ButtonPressed_GaragePlacement()
	toggleGaragePlacementClicked()
end

function ButtonPressed_GarageSize()
	toggleGarageSizeClicked()
end

function ButtonPressed_GarageMilitary()
	toggleMilitaryClicked()
end

function ButtonPressed_ShowHidePreview()
	toggleShowPreviewClicked()
end

function ButtonPressed_BuildFloor()
	if this.TimeWarp ~= nil then
		toggleBuildFloorClicked()
		Interface.SetReportTabs( "reportTab_tab1","reportTab_tab2","reportTab_tab3","reportTab_tab4","reportTab_tab5")
		timeTot = timePerUpdate
	end
end

function ButtonPressed_CheckObjects()
	toggleScanInventoryClicked()
    Interface.SetReportTabs( "reportTab_tab1","reportTab_tab2","reportTab_tab3","reportTab_tab4","reportTab_tab5")
end
