
--    Name                 Limo
--    Height               5  
--    SpriteScale          1.4

local timeTot=0
local Get = Object.GetProperty
local Set = Object.SetProperty
local Find = Object.GetNearbyObjects
local MyMarker={}
local NeighbourMarkerLeft={}
local NeighbourMarkerRight={}
local MarkerFound=false

function FindMyRoadMarker()
	--print("FindMyRoadMarker")
    local nearbyObject = Find(this,"RoadMarker",1500)
	if next(nearbyObject) then
		--print("some markers found")
		for thatMarker,dist in pairs(nearbyObject) do
			--print("marker pos.x: "..thatMarker.Pos.x.." this x: "..this.Pos.x)
			if thatMarker.Pos.x>=this.Pos.x-0.1 and thatMarker.Pos.x<=this.Pos.x+0.1 then
				MyMarker=thatMarker
				--print("marker found")
				Set(this,"MarkerUID",Get(thatMarker,"MarkerUID"))
				markerFound = true
				for nameL,dist in pairs(nearbyObject) do		-- also get my neighbourmarker if this marker is on a double lane
					if nameL.Pos.x==this.Pos.x-3 then
						NeighbourMarkerLeft=nameL
						break
					end
				end
				for nameR,dist in pairs(nearbyObject) do		-- also get my neighbourmarker if this marker is on a double lane
					if nameR.Pos.x==this.Pos.x+3 then
						NeighbourMarkerRight=nameR
						break
					end
				end
				break
			end
		end
	end
	nearbyObject = nil
end

function WaitForGateToOpen()
	--print("WaitForGateToOpen")
	if Get(this,"GateCount")<=Get(MyMarker,"TotalGates") then
		if Get(MyMarker,"Authorized"..this.GateCount) ~= this.HomeUID then
			if Get(MyMarker,"GatePosY"..this.GateCount) - MyHeadLights <= 1 or (Get(MyMarker,"LargeGate"..this.GateCount)=="yes" and Get(MyMarker,"GatePosY"..this.GateCount) - MyHeadLights <= 1.5) then
				this.VelY = 0
				if Get(MyMarker,"RequestFrom"..this.GateCount) == "none" then
					Set(MyMarker,"RequestFrom"..this.GateCount,this.HomeUID)
					if Get(MyMarker,"LargeGate"..this.GateCount)=="yes" then
						if Get(MyMarker,"GatePosX"..this.GateCount)==this.Pos.x+1.5 and next(NeighbourMarkerRight) then
							Set(NeighbourMarkerRight,"RequestFrom"..this.GateCount,this.HomeUID)
						elseif Get(MyMarker,"GatePosX"..this.GateCount)==this.Pos.x-1.5 and next(NeighbourMarkerLeft) then
							Set(NeighbourMarkerLeft,"RequestFrom"..this.GateCount,this.HomeUID)
						end
					end
				end
				if Get(MyMarker,"LinkGate"..this.GateCount)~="no" then
					for j=1,Get(MyMarker,"TotalGates") do
						if Get(MyMarker,"LinkGate"..j)==Get(MyMarker,"LinkGate"..this.GateCount) and Get(MyMarker,"RequestFrom"..j) == "none" then
							Set(MyMarker,"RequestFrom"..j,this.HomeUID)
							if Get(MyMarker,"LargeGate"..j)=="yes" then
								if Get(MyMarker,"GatePosX"..j)==this.Pos.x+1.5 and next(NeighbourMarkerRight) then
									Set(NeighbourMarkerRight,"RequestFrom"..j,this.HomeUID)
								elseif Get(MyMarker,"GatePosX"..j)==this.Pos.x-1.5 and next(NeighbourMarkerLeft) then
									Set(NeighbourMarkerLeft,"RequestFrom"..j,this.HomeUID)
								end
							end
						end
					end
				end
			end
		end
		if Get(MyMarker,"LinkGate"..this.GateCount)=="no" then
			if Get(MyMarker,"Authorized"..this.GateCount)==this.HomeUID and Get(MyMarker,"GateOpen"..this.GateCount)==1 then
				Set(this,"GateCount",this.GateCount+1)
			end
		else
			if Get(MyMarker,"GatePosY"..this.GateCount) - MyHeadLights <= 4 then
				local gatesopencounter=0
				local linkedgatescounter=0
				for j=1,Get(MyMarker,"TotalGates") do
					if Get(MyMarker,"LinkGate"..j)==Get(MyMarker,"LinkGate"..this.GateCount) then
						linkedgatescounter=linkedgatescounter+1
						if (Get(MyMarker,"Authorized"..j)==this.HomeUID and Get(MyMarker,"GateOpen"..j)==1) or (Get(MyMarker,"Authorized"..j)~="none" and Get(MyMarker,"GateOpen"..j)==1 and Get(MyMarker,"LargeGate"..this.GateCount)=="yes") then
							gatesopencounter=gatesopencounter+1
						end
					end
				end
				if gatesopencounter==linkedgatescounter then
					Set(this,"GateCount",this.GateCount+linkedgatescounter)
				else
					this.VelY = 0
				end
			end
		end
	end
end

function CloseGatesBehindMe(forced)
	for i=1,this.GateCount do
		if Get(MyMarker,"Authorized"..i)==this.HomeUID then
			if MyTailLights-Get(MyMarker,"GatePosY"..i) > 0 then
				Set(MyMarker,"CloseGate"..i,"yes")
				if Get(MyMarker,"LargeGate"..i)=="yes" then
					if Get(MyMarker,"GatePosX"..i)==this.Pos.x+1.5 and next(NeighbourMarkerRight) then
						Set(NeighbourMarkerRight,"CloseGate"..i,"yes")
					elseif Get(MyMarker,"GatePosX"..i)==this.Pos.x-1.5 and next(NeighbourMarkerLeft) then
						Set(NeighbourMarkerLeft,"CloseGate"..i,"yes")
					end
				end
			end
			if MyTailLights-Get(MyMarker,"GatePosY"..i) > 3 or forced then 
				for j=1,this.GateCount do
					if Get(MyMarker,"LinkGate"..j)==Get(MyMarker,"LinkGate"..i) then
						Set(MyMarker,"Authorized"..i,"no")
						Set(MyMarker,"CloseGate"..i,"no")
						if Get(MyMarker,"LargeGate"..i)=="yes" then
							if Get(MyMarker,"GatePosX"..i)==this.Pos.x+1.5 and next(NeighbourMarkerRight) then
								Set(NeighbourMarkerRight,"Authorized"..i,"no")
								Set(NeighbourMarkerRight,"CloseGate"..i,"no")
							elseif Get(MyMarker,"GatePosX"..i)==this.Pos.x-1.5 and next(NeighbourMarkerLeft) then
								Set(NeighbourMarkerLeft,"Authorized"..i,"no")
								Set(NeighbourMarkerLeft,"CloseGate"..i,"no")
							end
						end
					end
				end
			end
		end
	end
end

function FindVehicleBehindMe()
	--print("FindVehicleBehindMe")
	local CurrDist = 9999
	local tmpMyVehicleBehind = nil
	local group = {"TowTruck2WithLimo","TowTruck2WithCarParts","Limo2"}
	for _, typ in pairs(group) do
		local nearbyObject = Find(typ,500)
		for V, distance in pairs(nearbyObject) do
			if V.Id.i ~= this.Id.i and V.VehicleState ~= "Processing" and V.VehicleState ~= "EnteringGarage" and V.Pos.x >= this.Pos.x-3 and V.Pos.x <= this.Pos.x+3 and V.Pos.y < this.Pos.y-4 and this.Pos.y-V.Pos.y < CurrDist then
				CurrDist = distance
				tmpMyVehicleBehind=V
				--print("My x: "..this.Pos.x.."  My y: "..this.Pos.y.."   "..V.HomeUID.." found behind me at x: "..V.Pos.x.." y: "..V.Pos.y.." Dist: "..CurrDist)
			end
		end
	end
	nearbyObject=nil
	if tmpMyVehicleBehind ~= nil and tmpMyVehicleBehind.SubType ~= nil then
		MyVehicleBehind = tmpMyVehicleBehind
		Set(MyVehicleBehind,"VehicleTypeInFront",this.Type)
		Set(MyVehicleBehind,"DistanceInFront",CurrDist+5)
		Set(MyVehicleBehind,"FollowingID",this.Id.i)
		Set(this,"FollowUpID",MyVehicleBehind.Id.i)
		Set(MyVehicleBehind,"UpdateVehicleInFront",true)
		VehicleHeadLights = MyVehicleBehind.Pos.y + MyVehicleBehind.Head
		--print("MyVehicleBehind is "..MyVehicleBehind.HomeUID)
	else
		MyVehicleBehind = nil
	end
end

function FindVehicleInFront()
	--print("FindVehicleInFront")
	local CurrDist = 9999
	local tmpMyVehicleInFront = nil
	local group = {"TowTruck2WithLimo","TowTruck2WithCarParts","Limo2"}
	for _, typ in pairs(group) do
		local nearbyObject = Find(typ,500)
		for V, distance in pairs(nearbyObject) do
			if V.Pos.x ~= nil and V.Id.i ~= this.Id.i and V.VehicleState ~= "Processing" and V.VehicleState ~= "EnteringGarage" and V.Pos.x >= this.Pos.x-3 and V.Pos.x <= this.Pos.x+3 and V.Pos.y >= this.Pos.y-4 and V.Pos.y-this.Pos.y < CurrDist then
				if this.VehicleState == "LeavingGarage" then
					CurrDist = distance
					tmpMyVehicleInFront=V
					--print("My x: "..this.Pos.x.."  My y: "..this.Pos.y.."   "..V.HomeUID.." found in front at x: "..V.Pos.x.." y: "..V.Pos.y.." Dist: "..CurrDist)
				elseif V.FollowUpID == -1 then
					CurrDist = distance
					tmpMyVehicleInFront=V
					--print("My x: "..this.Pos.x.."  My y: "..this.Pos.y.."   "..V.HomeUID.." found in front at x: "..V.Pos.x.." y: "..V.Pos.y.." Dist: "..CurrDist)
				end
			end
		end
	end
	nearbyObject=nil
	if tmpMyVehicleInFront ~= nil and tmpMyVehicleInFront.SubType ~= nil then
		MyVehicleInFront = tmpMyVehicleInFront
		Set(MyVehicleInFront,"VehicleTypeBehind",this.Type)
		Set(MyVehicleInFront,"DistanceBehind",CurrDist+5)
		Set(MyVehicleInFront,"FollowUpID",this.Id.i)
		Set(this,"FollowingID",MyVehicleInFront.Id.i)
		Set(MyVehicleInFront,"UpdateVehicleBehind",true)
		VehicleTailLights = MyVehicleInFront.Pos.y - MyVehicleInFront.Tail
		--print("MyVehicleInFront is "..MyVehicleInFront.HomeUID)
	else
		MyVehicleInFront = nil
	end
end

function LoadVehicleBehindMe()
	--print("LoadVehicleBehind")
	local vFound = false
	if this.VehicleTypeBehind ~= "None" then
		--print("trying to find"..this.VehicleTypeBehind.." at distance "..this.DistanceBehind)
		local vehicles = Find(this.VehicleTypeBehind,this.DistanceBehind)
		for V, _ in pairs(vehicles) do
			if Get(V,"FollowingID") == this.Id.i and this.FollowUpID == V.Id.i then --and V.VehicleState ~= "Processing" and V.VehicleState ~= "EnteringGarage" then
				tmpMyVehicleBehind=V
				vFound = true
				break
			end
		end
		vehicles=nil
	end
	if vFound == true then
		MyVehicleBehind = tmpMyVehicleBehind
		VehicleHeadLights = MyVehicleBehind.Pos.y + MyVehicleBehind.Head
		--print("MyVehicleBehind is "..MyVehicleBehind.HomeUID)
	else
		MyVehicleBehind = nil
		--print("MyVehicleBehind not found")
		FindVehicleBehindMe()
	end
end

function LoadVehicleInFront()
	--print("LoadVehicleInFront")
	local vFound = false
	if this.VehicleTypeInFront ~= "None" then
		--print("trying to find"..this.VehicleTypeInFront.." at distance "..this.DistanceInFront)
		local vehicles = Find(this.VehicleTypeInFront,this.DistanceInFront)
		for V, _ in pairs(vehicles) do
			if Get(V,"FollowUpID") == this.Id.i and this.FollowingID == V.Id.i then --and V.VehicleState ~= "Processing" and V.VehicleState ~= "EnteringGarage" then
				tmpMyVehicleInFront=V
				vFound = true
				break
			end
		end
		vehicles=nil
	end
	if vFound == true then
		MyVehicleInFront = tmpMyVehicleInFront
		VehicleTailLights = MyVehicleInFront.Pos.y - MyVehicleInFront.Tail
		--print("MyVehicleInFront is "..MyVehicleInFront.HomeUID)
	else
		MyVehicleInFront = nil
		--print("MyVehicleInFront not found")
		FindVehicleInFront()
	end
end

function Create()
	Set(this,"Tail",2)
	Set(this,"Head",2)
	Set(this,"HomeUID","Limo_"..me["id-uniqueId"])
	Set(this,"GateCount",1)
	Set(this,"VelX",0)
	Set(this,"VelY",0)
	Set(this,"FollowingID",-1)
	Set(this,"FollowUpID",-1)
	Set(this,"VehicleState","LeavingGarage")
	Set(this,"UpdateVehicleBehind",false)
	Set(this,"DistanceBehind",0)
	Set(this,"VehicleTypeBehind","None")
	Set(this,"UpdateVehicleInFront",false)
	Set(this,"DistanceInFront",0)
	Set(this,"VehicleTypeInFront","None")
end

function RemoveDriver()
    local nearbyObject = Find(this,"Limo2DriverLeaving",4)
	if next(nearbyObject) then
		for thatDriver, dist in pairs(nearbyObject) do
			if thatDriver.CarUID == this.CarUID then
				thatDriver.Delete()
				break
			end
		end
	end
    local nearbyObject = Find(this,"Limo2Window",4)
	if next(nearbyObject) then
		for thatWindow, dist in pairs(nearbyObject) do
			if thatWindow.CarUID == this.CarUID then
				thatWindow.Delete()
				break
			end
		end
	end
end

function DeleteVehicleClicked()
	this.Delete() 
end

function FindMapEdge()
	local endY=-1
	local foundEndY=false
	
	while foundEndY==false do
		endY=endY+1
		local myCell = World.GetCell(this.Pos.x,endY)
		if myCell.Mat==nil then
			foundEndY=true
			endY=endY-1
		end
	end
	Set("MapBottom",endY)
end

function Update(timePassed)
	if timePerUpdate == nil then
		Interface.AddComponent( this,"DeleteVehicle", "Button", "Delete")
		if Get(this,"VelY")==nil then
			Set(this,"VelX",0)
			Set(this,"VelY",0)
		end
		FindMyRoadMarker()
		if Get(this,"FollowingID") == -1 then
			FindVehicleInFront()
		else
			LoadVehicleInFront()
		end
		if Get(this,"FollowUpID") == -1 then
			FindVehicleBehindMe()
		else
			LoadVehicleBehindMe()
		end
		FindMapEdge()
		if Get(this,"HomeUID")==nil then this.Delete() end
		timePerUpdate=0.2
	end
	timeTot=timeTot+timePassed
	if timeTot>=timePerUpdate then
		timeTot=0
		
		if Get(this,"UpdateVehicleBehind") == true then
			LoadVehicleBehindMe()
			Set(this,"UpdateVehicleBehind",false)
		end
		if Get(this,"UpdateVehicleInFront") == true then
			LoadVehicleInFront()
			Set(this,"UpdateVehicleInFront",false)
		end
		MyTailLights = this.Pos.y - this.Tail
		MyHeadLights = this.Pos.y + this.Head
		if MyVehicleBehind ~= nil and MyVehicleBehind.SubType ~= nil then
			VehicleHeadLights = MyVehicleBehind.Pos.y + MyVehicleBehind.Head
		end
		if MyVehicleInFront ~= nil and MyVehicleInFront.SubType ~= nil then
			VehicleTailLights = MyVehicleInFront.Pos.y - MyVehicleInFront.Tail
		end
		
		if this.Pos.y >= this.MapBottom-1 then
			CloseGatesBehindMe(true)
			if this.IsMilitary == "Yes" then
				RemoveDriver()
			end
			this.Delete()
		end
		
		timePerUpdate = 0.2		
		if this.VelY < 2 then
			this.VelY = this.VelY+0.5
		end
		if MyMarker ~= nil and MyMarker.TotalGates ~= nil then CloseGatesBehindMe() end
		if MyMarker ~= nil and MyMarker.TotalGates ~= nil and MyMarker.TotalGates >= this.GateCount and Get(MyMarker,"RequestFrom"..this.GateCount)~=this.HomeUID and (Get(MyMarker,"GatePosY"..this.GateCount) - MyHeadLights <= 1 or (Get(MyMarker,"LargeGate"..this.GateCount)=="yes" and Get(MyMarker,"GatePosY"..this.GateCount) - MyHeadLights <= 1.5)) then
			timePerUpdate = 1
			WaitForGateToOpen()
		elseif MyVehicleInFront ~= nil and MyVehicleInFront.SubType ~= nil and VehicleTailLights - MyHeadLights < 3 then
			timePerUpdate = 0
			this.VelY = VehicleTailLights - MyHeadLights - 0.5			-- - 1.9
			if this.VelY < 0.01 then
				this.VelY = 0
				timePerUpdate = 1
			end
		else
			if MyMarker ~= nil and MyMarker.TotalGates ~= nil and MyMarker.TotalGates >= this.GateCount and (Get(MyMarker,"GatePosY"..this.GateCount) - MyHeadLights) < 3 then
				timePerUpdate = 0
			--	if Get(MyMarker,"LargeGate"..this.GateCount)=="yes" then
			--		this.VelY = (Get(MyMarker,"GatePosY"..this.GateCount) - MyHeadLights)-- - 1.4
			--	else
					this.VelY = (Get(MyMarker,"GatePosY"..this.GateCount) - MyHeadLights) - 0.5			-- - 0.9
			--	end
			else
				timePerUpdate = 0.2	
				if this.VelY < 3 then
					this.VelY = this.VelY+0.1
				end
			end
		end
		Object.ApplyVelocity(this,this.VelX,this.VelY,false)
		
		if MyMarker ~= nil and MyMarker.TotalGates ~= nil then
			local tmpGC = this.GateCount
			local tmpDistG = 0
			if Get(MyMarker,"GatePosY"..this.GateCount) ~= nil then tmpDistG = Get(MyMarker,"GatePosY"..this.GateCount) - MyHeadLights end
			local tmpBehind = "none"
			local tmpDistB = 0
			if MyVehicleBehind ~= nil and MyVehicleBehind.SubType ~= nil then tmpBehind = MyVehicleBehind.HomeUID; tmpDistB = MyTailLights - VehicleHeadLights end
			local tmpFront = "none"
			local tmpDistF = 0
			if MyVehicleInFront ~= nil and MyVehicleInFront.SubType ~= nil then tmpFront = MyVehicleInFront.HomeUID; tmpDistF = VehicleTailLights - MyHeadLights end
			
			if MyMarker ~= nil and MyMarker.TotalGates >= this.GateCount then
				this.Tooltip="\nVehicle ID: "..this.HomeUID.."\n\nCrane ID: "..this.CraneUID.."\n\nDistance to gate ("..tmpGC..") is: "..tmpDistG.."\n\nVehicle Speed: "..this.VelY.."\n\nVehicle behind me: "..tmpBehind.."\nDistance: "..tmpDistB.."\n\nVehicle in front: "..tmpFront.."\nDistance: "..tmpDistF
			else
				this.Tooltip="\nVehicle ID: "..this.HomeUID.."\n\nCrane ID: "..this.CraneUID.."\n\nVehicle Speed: "..this.VelY.."\n\nVehicle behind me: "..tmpBehind.."\nDistance: "..tmpDistB.."\n\nVehicle in front: "..tmpFront.."\nDistance: "..tmpDistF
			end
			--CloseGatesBehindMe()
		else
			if MarkerFound==true then	-- marker got replaced by a new one, delete vehicle
				this.Delete()
			end							-- else there were no markers at all, so do nothing
		end
	end
end
