
local timeTot = 0
local Set = Object.SetProperty
local Get = Object.GetProperty
local Find = Object.GetNearbyObjects

function FindMyBooth()
	local nearbyObject = Find("GantryCrane2Booth",50)
	if next(nearbyObject) then
		for thatBooth, distance in pairs(nearbyObject) do
			if thatBooth.HomeUID==this.HomeUID then
				--print("MyCraneBooth found")
				MyCraneBooth=thatBooth
				break
			end
		end
	end
	nearbyObject = nil
end

function FindMyRack()
	local nearbyObject = Find("CarPartsRack2",50)
	if next(nearbyObject) then
		for thatRack, distance in pairs(nearbyObject) do
			if thatRack.HomeUID==this.HomeUID then
				--print("MyRack found")
				MyRack=thatRack
			end
		end
	end
	nearbyObject = nil
end

function FindMyEngine()
	MyEngine = nil
	Set(this,"CountDown",false)
	local nearbyObject = Find("Limo2Engine",3)
	if next(nearbyObject) then
		for thatEngine, distance in pairs(nearbyObject) do
			if thatEngine.Id.i==this.Slot0.i then
				--print("MyEngine found")
				MyEngine=thatEngine
				Set(this,"CountDown",true)
				MyEngine.Tooltip= { "tooltip_limo2lesson",this.CarUID,"X",this.LessonSpot,"Y" }
			end
		end
	end
	nearbyObject = nil
end

function CheckAvailableEngineSlots()
	AvailableEngineSlots = 0
	if MyCraneBooth == nil then FindMyBooth() end
	if MyRack == nil then FindMyRack() end
	for i=0,7 do
		if Get(MyRack,"Slot"..i..".i") == -1 then
			--print("MyRack slot "..i.." is free")
			AvailableEngineSlots = AvailableEngineSlots+1
		end
	end
	if AvailableEngineSlots > 0 then
		Set(MyCraneBooth,"BringToRack"..this.LessonSpot,true)
		Set(this,"CountDown",false)
		Set(this,"EngineJobIssued",nil)
		MyEngine = nil
	else
		Object.CreateJob(this,"RemoveEngine2")
	end
end

function Create()
	Set(this,"CarUID","Limo2Lesson_"..me["id-uniqueId"])
end

function JobComplete_RefurbishEngine2()
	if MyEngine == nil or MyEngine.SubType == nil then FindMyEngine() end
	if MyEngine ~= nil then
		if Get(MyEngine,"Damage") < 0.1 then
			Set(MyEngine,"Damage",0)
			Set(this,"EngineDamage",0)
			Set(this,"CountDown",false)
			Set(this,"EngineJobIssued",false)
		else
			Set(MyEngine,"Damage",MyEngine.Damage - 0.1)
			Set(this,"EngineDamage",MyEngine.Damage)
			Set(this,"EngineJobIssued",false)
		end
	end
end

function JobComplete_RemoveEngine2()
	newRubbish = Object.Spawn("Rubble",this.Pos.x+math.random(-1,1),this.Pos.y+1+math.random(-1,1))
	local velX = -1.0 + math.random() + math.random()
	local velY = -1.0 + math.random() + math.random()
	Object.ApplyVelocity(newRubbish, velX, velY)
	newRubbish = Object.Spawn("Rubble",this.Pos.x+math.random(-1,1),this.Pos.y+1+math.random(-1,1))
	local velX = -1.0 + math.random() + math.random()
	local velY = -1.0 + math.random() + math.random()
	Object.ApplyVelocity(newRubbish, velX, velY)
	newRubbish = Object.Spawn("Rubble",this.Pos.x+math.random(-1,1),this.Pos.y+1+math.random(-1,1))
	local velX = -1.0 + math.random() + math.random()
	local velY = -1.0 + math.random() + math.random()
	Object.ApplyVelocity(newRubbish, velX, velY)
	if MyEngine == nil or MyEngine.SubType == nil then FindMyEngine() end
	if MyEngine ~= nil then
		MyEngine.Delete()
	end
	MyEngine = nil
	Set(this,"CountDown",false)
	Set(this,"EngineJobIssued",false)
end