
local Set = Object.SetProperty
local Get = Object.GetProperty
local Find = this.GetNearbyObjects
local TickTock=false
local timeTot=0

function Create()
end

function DoInit()
--	Set(this,"BuildRoad",false)
	Set(this,"CargoMarkerID",0)
	Set(this,"IntakeMarkerID",0)
	Set(this,"EmergencyMarkerID",0)
	Set(this,"GarageMarkerID",0)
	Set(this,"CargoTraffic","no")
	Set(this,"IntakeTraffic","no")
	Set(this,"EmgTraffic","no")
	Set(this,"GarageTraffic","no")
	Set(this,"TotalBusStops",0)
	Set(this,"Sub",0)
	Set(this,"LinkGate1","no")
	Set(this,"LinkGate2","no")
	Set(this,"LinkGate3","no")
	Set(this,"LinkGate4","no")
	Set(this,"LinkGate5","no")
	Set(this,"LinkGate6","no")
	Set(this,"LinkGate7","no")
	Set(this,"LinkGate8","no")
	Set(this,"LinkGate9","no")
	Set(this,"LinkGate10","no")
	Set(this,"LinkGate11","no")
	Set(this,"GatePosY1",0)
	Set(this,"GatePosY2",0)
	Set(this,"GatePosY3",0)
	Set(this,"GatePosY4",0)
	Set(this,"GatePosY5",0)
	Set(this,"GatePosY6",0)
	Set(this,"GatePosY7",0)
	Set(this,"GatePosY8",0)
	Set(this,"GatePosY9",0)
	Set(this,"GatePosY10",0)
	Set(this,"GatePosY11",0) -- buffer gate
    local managers = Find("StreetManager",1500);
	if next(managers) then
		for thatManager, distance in pairs(managers) do
			thatManager.Delete()
		end
		MyManager=Object.Spawn("StreetManager",FindLeftRoadSide()+0.25000,0.5000000)
	end
	managers=nil
end

function BuildRoadClicked()
	BuildMyRoad()
end

function BuildMyRoad()
	local endY=-1
	local foundEndY=false
	while foundEndY==false do
		endY=endY+1
		local myCell = World.GetCell(this.Pos.x,endY)
		if myCell.Mat==nil then
			foundEndY=true
			endY=endY-1
		else
			local myCellA = World.GetCell(this.Pos.x-3,endY)
			local myCellB = World.GetCell(this.Pos.x-2,endY)
			local myCellC = World.GetCell(this.Pos.x-1,endY)
			local myCellD = World.GetCell(this.Pos.x,endY)
			local myCellE = World.GetCell(this.Pos.x+1,endY)
			if myCellA.Mat~="RoadMarkingsRight" then
				myCellB.Mat="ConcreteTiles"; myCellC.Mat="RoadMarkingsLeft"; myCellD.Mat="RoadMarkingsRight"; myCellE.Mat="ConcreteTiles"
			else
				if TickTock==false then				-- toggle for center road markings on double lane
					myCellA.Mat="Road"; myCellB.Mat="RoadMarkings"; myCellC.Mat="Road"; myCellD.Mat="RoadMarkingsRight"; myCellE.Mat="ConcreteTiles"
					TickTock=true
				else
					myCellA.Mat="Road"; myCellB.Mat="Road"; myCellC.Mat="Road"; myCellD.Mat="RoadMarkingsRight"; myCellE.Mat="ConcreteTiles"
					TickTock=false
				end
			end
		end
	end
	RemoveTrees()
end

function RemoveTrees()
	local nearbyTrees=Find("Tree",1500)
	for thatTree, distance in pairs(nearbyTrees) do
		if thatTree.Pos.x>=math.floor(this.Pos.x)-3 and thatTree.Pos.x<=math.ceil(this.Pos.x)+3 then
			thatTree.Delete()
		end
	end
	nearbyTrees=nil
end

function DoResetMarkerClicked()
	this.Sound("_Deployment","SetNone")
	if Get(MyManager,"cargocount")~=nil then MyManager.Delete() end
	newMarker=Object.Spawn("RoadMarker",this.Pos.x,this.Pos.y)
	this.Delete()
end

function AddLinkButtonsClicked()
	Interface.RemoveComponent(this,"AddLinkButtons", "Button", "Setup gate links")
	for i=1,this.TotalGates do
		Interface.RemoveComponent(this,"toggleLinkGate"..i,"Button","tooltip_button_LinkGate"..i,Get(this,"GatePosY"..i),"P",Get(this,"LinkGate"..i),"X")
	end
	for i=1,this.TotalGates do
		Interface.AddComponent(this,"toggleLinkGate"..i,"Button","tooltip_button_LinkGate"..i,Get(this,"GatePosY"..i),"P",Get(this,"LinkGate"..i),"X")
	end
end

function toggleLinkGate1Clicked()
	if Get(this,"LinkGate1")=="no" then Set(this,"LinkGate1","A")
	elseif Get(this,"LinkGate1")=="A" then Set(this,"LinkGate1","B")
	elseif Get(this,"LinkGate1")=="B" then Set(this,"LinkGate1","C")
	elseif Get(this,"LinkGate1")=="C" then Set(this,"LinkGate1","D")
	elseif Get(this,"LinkGate1")=="D" then Set(this,"LinkGate1","E")
	elseif Get(this,"LinkGate1")=="E" then Set(this,"LinkGate1","no") end
	this.SetInterfaceCaption("toggleLinkGate1","tooltip_button_LinkGate1",this.GatePosY1,"P",this.LinkGate1,"X")
end

function toggleLinkGate2Clicked()
	if Get(this,"LinkGate2")=="no" then Set(this,"LinkGate2","A")
	elseif Get(this,"LinkGate2")=="A" then Set(this,"LinkGate2","B")
	elseif Get(this,"LinkGate2")=="B" then Set(this,"LinkGate2","C")
	elseif Get(this,"LinkGate2")=="C" then Set(this,"LinkGate2","D")
	elseif Get(this,"LinkGate2")=="D" then Set(this,"LinkGate2","E")
	elseif Get(this,"LinkGate2")=="E" then Set(this,"LinkGate2","no") end
	this.SetInterfaceCaption("toggleLinkGate2","tooltip_button_LinkGate2",this.GatePosY2,"P",this.LinkGate2,"X")
end

function toggleLinkGate3Clicked()
	if Get(this,"LinkGate3")=="no" then Set(this,"LinkGate3","A")
	elseif Get(this,"LinkGate3")=="A" then Set(this,"LinkGate3","B")
	elseif Get(this,"LinkGate3")=="B" then Set(this,"LinkGate3","C")
	elseif Get(this,"LinkGate3")=="C" then Set(this,"LinkGate3","D")
	elseif Get(this,"LinkGate3")=="D" then Set(this,"LinkGate3","E")
	elseif Get(this,"LinkGate3")=="E" then Set(this,"LinkGate3","no") end
	this.SetInterfaceCaption("toggleLinkGate3","tooltip_button_LinkGate3",this.GatePosY3,"P",this.LinkGate3,"X")
end

function toggleLinkGate4Clicked()
	if Get(this,"LinkGate4")=="no" then Set(this,"LinkGate4","A")
	elseif Get(this,"LinkGate4")=="A" then Set(this,"LinkGate4","B")
	elseif Get(this,"LinkGate4")=="B" then Set(this,"LinkGate4","C")
	elseif Get(this,"LinkGate4")=="C" then Set(this,"LinkGate4","D")
	elseif Get(this,"LinkGate4")=="D" then Set(this,"LinkGate4","E")
	elseif Get(this,"LinkGate4")=="E" then Set(this,"LinkGate4","no") end
	this.SetInterfaceCaption("toggleLinkGate4","tooltip_button_LinkGate4",this.GatePosY4,"P",this.LinkGate4,"X")
end

function toggleLinkGate5Clicked()
	if Get(this,"LinkGate5")=="no" then Set(this,"LinkGate5","A")
	elseif Get(this,"LinkGate5")=="A" then Set(this,"LinkGate5","B")
	elseif Get(this,"LinkGate5")=="B" then Set(this,"LinkGate5","C")
	elseif Get(this,"LinkGate5")=="C" then Set(this,"LinkGate5","D")
	elseif Get(this,"LinkGate5")=="D" then Set(this,"LinkGate5","E")
	elseif Get(this,"LinkGate5")=="E" then Set(this,"LinkGate5","no") end
	this.SetInterfaceCaption("toggleLinkGate5","tooltip_button_LinkGate5",this.GatePosY5,"P",this.LinkGate5,"X")
end

function toggleLinkGate6Clicked()
	if Get(this,"LinkGate6")=="no" then Set(this,"LinkGate6","A")
	elseif Get(this,"LinkGate6")=="A" then Set(this,"LinkGate6","B")
	elseif Get(this,"LinkGate6")=="B" then Set(this,"LinkGate6","C")
	elseif Get(this,"LinkGate6")=="C" then Set(this,"LinkGate6","D")
	elseif Get(this,"LinkGate6")=="D" then Set(this,"LinkGate6","E")
	elseif Get(this,"LinkGate6")=="E" then Set(this,"LinkGate6","no") end
	this.SetInterfaceCaption("toggleLinkGate6","tooltip_button_LinkGate6",this.GatePosY6,"P",this.LinkGate6,"X")
end

function toggleLinkGate7Clicked()
	if Get(this,"LinkGate7")=="no" then Set(this,"LinkGate7","A")
	elseif Get(this,"LinkGate7")=="A" then Set(this,"LinkGate7","B")
	elseif Get(this,"LinkGate7")=="B" then Set(this,"LinkGate7","C")
	elseif Get(this,"LinkGate7")=="C" then Set(this,"LinkGate7","D")
	elseif Get(this,"LinkGate7")=="D" then Set(this,"LinkGate7","E")
	elseif Get(this,"LinkGate7")=="E" then Set(this,"LinkGate7","no") end
	this.SetInterfaceCaption("toggleLinkGate7","tooltip_button_LinkGate7",this.GatePosY7,"P",this.LinkGate7,"X")
end

function toggleLinkGate8Clicked()
	if Get(this,"LinkGate8")=="no" then Set(this,"LinkGate8","A")
	elseif Get(this,"LinkGate8")=="A" then Set(this,"LinkGate8","B")
	elseif Get(this,"LinkGate8")=="B" then Set(this,"LinkGate8","C")
	elseif Get(this,"LinkGate8")=="C" then Set(this,"LinkGate8","D")
	elseif Get(this,"LinkGate8")=="D" then Set(this,"LinkGate8","E")
	elseif Get(this,"LinkGate8")=="E" then Set(this,"LinkGate8","no") end
	this.SetInterfaceCaption("toggleLinkGate8","tooltip_button_LinkGate8",this.GatePosY8,"P",this.LinkGate8,"X")
end

function toggleLinkGate9Clicked()
	if Get(this,"LinkGate9")=="no" then Set(this,"LinkGate9","A")
	elseif Get(this,"LinkGate9")=="A" then Set(this,"LinkGate9","B")
	elseif Get(this,"LinkGate9")=="B" then Set(this,"LinkGate9","C")
	elseif Get(this,"LinkGate9")=="C" then Set(this,"LinkGate9","D")
	elseif Get(this,"LinkGate9")=="D" then Set(this,"LinkGate9","E")
	elseif Get(this,"LinkGate9")=="E" then Set(this,"LinkGate9","no") end
	this.SetInterfaceCaption("toggleLinkGate9","tooltip_button_LinkGate9",this.GatePosY9,"P",this.LinkGate9,"X")
end

function toggleLinkGate10Clicked()
	if Get(this,"LinkGate10")=="no" then Set(this,"LinkGate10","A")
	elseif Get(this,"LinkGate10")=="A" then Set(this,"LinkGate10","B")
	elseif Get(this,"LinkGate10")=="B" then Set(this,"LinkGate10","C")
	elseif Get(this,"LinkGate10")=="C" then Set(this,"LinkGate10","D")
	elseif Get(this,"LinkGate10")=="D" then Set(this,"LinkGate10","E")
	elseif Get(this,"LinkGate10")=="E" then Set(this,"LinkGate10","no") end
	this.SetInterfaceCaption("toggleLinkGate10","tooltip_button_LinkGate10",this.GatePosY10,"P",this.LinkGate10,"X")
end

function toggleCargoClicked()
	if Get(this,"CargoTraffic")=="no" then
		if Get(this,"Sub")==1 then
			Set(this,"GarageTraffic","no")
			Set(this,"Sub",0)
			this.SetInterfaceCaption("toggleGarage","tooltip_button_garage",this.GarageTraffic,"X")
		end
		Set(this,"CargoTraffic","yes")
		Set(this,"Sub",this.Sub+2)
	else
		Set(this,"CargoTraffic","no")
		Set(this,"Sub",this.Sub-2)
	end
	this.SetInterfaceCaption("toggleCargo","tooltip_button_cargo",this.CargoTraffic,"X")
	if Get(this,"Sub")>7 then Set(this,"SubType",this.Sub-2) else Set(this,"SubType",this.Sub-1) end		-- Sub numbers explained in materials.txt
	this.Sound("_Deployment","SetNone")
end

function toggleIntakeClicked()
	if Get(this,"IntakeTraffic")=="no" then
		if Get(this,"Sub")==1 then
			Set(this,"GarageTraffic","no")
			Set(this,"Sub",0)
			this.SetInterfaceCaption("toggleGarage","tooltip_button_garage",this.GarageTraffic,"X")
		end
		Set(this,"IntakeTraffic","yes")
		Set(this,"Sub",this.Sub+3)
	else
		Set(this,"IntakeTraffic","no")
		Set(this,"Sub",this.Sub-3)
	end
	this.SetInterfaceCaption("toggleIntake","tooltip_button_intake",this.IntakeTraffic,"X")
	if this.Sub>7 then Set(this,"SubType",this.Sub-2) else Set(this,"SubType",this.Sub-1) end
	this.Sound("_Deployment","SetNone")
end

function toggleEmergencyClicked()
	if Get(this,"EmgTraffic")=="no" then
		if Get(this,"Sub")==1 then
			Set(this,"GarageTraffic","no")
			Set(this,"Sub",0)
			this.SetInterfaceCaption("toggleGarage","tooltip_button_garage",this.GarageTraffic,"X")
		end
		Set(this,"EmgTraffic","yes")
		Set(this,"Sub",this.Sub+4)
	else
		Set(this,"EmgTraffic","no")
		Set(this,"Sub",this.Sub-4)
	end
	this.SetInterfaceCaption("toggleEmergency","tooltip_button_emergency",this.EmgTraffic,"X")
	if this.Sub>7 then Set(this,"SubType",this.Sub-2) else Set(this,"SubType",this.Sub-1) end
	this.Sound("_Deployment","SetNone")
end

function toggleGarageClicked()
	if Get(this,"GarageTraffic")=="no" then
		Set(this,"GarageTraffic","yes")
		Set(this,"IntakeTraffic","no")
		Set(this,"EmgTraffic","no")
		Set(this,"CargoTraffic","no")
		Set(this,"Sub",1)
		this.SetInterfaceCaption("toggleCargo","tooltip_button_cargo",this.CargoTraffic,"X")
		this.SetInterfaceCaption("toggleIntake","tooltip_button_intake",this.IntakeTraffic,"X")
		this.SetInterfaceCaption("toggleEmergency","tooltip_button_emergency",this.EmgTraffic,"X")
	else
		Set(this,"GarageTraffic","no")
		Set(this,"Sub",0)
	end
	this.SetInterfaceCaption("toggleGarage","tooltip_button_garage",this.GarageTraffic,"X")
	if this.Sub==1 then Set(this,"SubType",8) else Set(this,"SubType",0) end
	this.Sound("_Deployment","SetNone")
end

function FindLeftRoadSide()
	local RoadTop=0
	local endY=-1
	local foundEndY=false
	while foundEndY==false do
		endY=endY+1
		local TopRowCell = World.GetCell(endY,0)
		if TopRowCell.Mat~=nil then
			if TopRowCell.Mat=="RoadMarkingsLeft" then
				foundEndY=true
				return endY-1
			end
		else
			foundEndY=true
			return 0
		end
	end
end

function FindMyManager()
    local managers = Find("StreetManager",1500);
	if next(managers) then
		for thatManager, distance in pairs(managers) do
			MyManager=thatManager
		end
	else
		MyManager=Object.Spawn("StreetManager",FindLeftRoadSide()+0.25000,0.5000000)
	end
	managers=nil
end

function CheckMyManager()
	if Get(MyManager,"cargocount")==nil then
		FindMyManager()
	end
end

function Update(TimePassed)
	if timeMax==nil then
		if this.CargoTraffic==nil then DoInit() end
	--	if this.GarageTraffic==nil then 
	--		Set(this,"GarageMarkerID",0)
	--		Set(this,"GarageTraffic","no")
	--	end
		if this.MarkerUID==nil then Set(this,"MarkerUID",me["id-uniqueId"]) end
		FindMyManager()
		Interface.AddComponent(this,"BuildRoad", "Button", "Build road")
		Interface.AddComponent(this,"DoResetMarker", "Button", "Reset Marker")
		Interface.AddComponent(this,"Separator0", "Caption", "tooltip_allowedtraffic")
		Interface.AddComponent(this,"toggleCargo", "Button", "tooltip_button_cargo",this.CargoTraffic,"X")
		Interface.AddComponent(this,"toggleIntake", "Button", "tooltip_button_intake",this.IntakeTraffic,"X")
		Interface.AddComponent(this,"toggleEmergency", "Button", "tooltip_button_emergency",this.EmgTraffic,"X")
		Interface.AddComponent(this,"toggleGarage", "Button", "tooltip_button_garage",this.GarageTraffic,"X")
		Interface.AddComponent(this,"Separator1", "Caption", "tooltip_separatorline")
		Interface.AddComponent(this,"AddLinkButtons", "Button", "Setup gate links")
		if Get(this,"BuildRoad") == true then
			BuildMyRoad()
			Set(this,"GarageTraffic","yes")
			this.SetInterfaceCaption("toggleGarage","tooltip_button_garage",this.GarageTraffic,"X")
			Set(this,"BuildRoad",false)
		end
		timeMax = 10+math.random()
	end

    timeTot = timeTot + TimePassed
    if timeTot>timeMax then
        timeTot=0
		if this.Pos.y~=0.5000000 then this.Pos.y=0.5000000 end
		CheckMyManager()
	end
end
