
local timeTot = 0

local Set = Object.SetProperty
local Get = Object.GetProperty
local Find = Object.GetNearbyObjects

local AllGates={}
local SortedGates={}
local SortedBusStops={}

function CacheMyGates()
--	print("CacheMyGates starting")
	local GatesToSort={}
	SortedGates={}
	for thatMarker,d in pairs(myMarkers) do
		SortedGates[thatMarker]={}
--		print("searching for AllSmallGates at "..thatMarker.Pos.x.."")
		local GateCounter=0
		for thatGate, distance in pairs(AllSmallGates) do
			if thatGate.Pos.x==thatMarker.Pos.x then
				GateCounter=GateCounter+1
--				print("found small gate "..GateCounter.." is at "..thatGate.Pos.x.." "..thatGate.Pos.y.."  ID: "..thatGate.Id.u.."")
				GatesToSort[GateCounter]=thatGate.Pos.y
			end	
		end
--		print("searching for AllBigGates at "..thatMarker.Pos.x.."")
		for thatGate, distance in pairs(AllBigGates) do
			if thatGate.Pos.x==thatMarker.Pos.x-1.5 or thatGate.Pos.x==thatMarker.Pos.x+1.5 then
				GateCounter=GateCounter+1
--				print("found big gate "..GateCounter.." is at "..thatGate.Pos.x.." "..thatGate.Pos.y.."  ID: "..thatGate.Id.u.."")
				GatesToSort[GateCounter]=thatGate.Pos.y
			end	
		end
		table.sort(GatesToSort)
		local j=0
		for i,n in ipairs(GatesToSort) do
			for thatGate,distance in pairs(AllSmallGates) do
				if thatGate.Pos.y==GatesToSort[i] and thatGate.Pos.y~=GatesToSort[i-1] and thatGate.Pos.x==thatMarker.Pos.x then -- needs thatGate.Pos.y~=GatesToSort[i-1] to prevent rare case double entries (?!?)
					j=j+1
--					print("sorted small gate "..j.." is at: "..thatGate.Pos.x.." "..thatGate.Pos.y.." ID: "..thatGate.Id.u.."")
					SortedGates[thatMarker][j]=thatGate
				end
			end
			for thatGate,distance in pairs(AllBigGates) do
				if thatGate.Pos.y==GatesToSort[i] and thatGate.Pos.y~=GatesToSort[i-1] and (thatGate.Pos.x==thatMarker.Pos.x-1.5 or thatGate.Pos.x==thatMarker.Pos.x+1.5) then
					j=j+1
--					print("sorted big gate "..j.." is at: "..thatGate.Pos.x.." "..thatGate.Pos.y.." ID: "..thatGate.Id.u.."")
					SortedGates[thatMarker][j]=thatGate
				end
			end
		end
	end
	for thatMarker, d in pairs(SortedGates) do
		ResetRoadMarker(thatMarker)
--		print("list for that marker")
		for i, theGate in pairs(SortedGates[thatMarker]) do
--			print("i: "..i.."   position "..theGate.Pos.x.."  "..theGate.Pos.y.."   mode "..theGate.Mode.."  id.u "..theGate.Id.u)
			Set(thatMarker,"GatePosX"..i,theGate.Pos.x)
			Set(thatMarker,"GatePosY"..i,theGate.Pos.y)
			Set(thatMarker,"GateOpen"..i,theGate.Open)
			Set(theGate,"GatePosition",i)
			Set(theGate,"MarkerUID",thatMarker.MarkerUID)
		--	Interface.AddComponent( theGate,"ResetGate", "Button", "Reset Gate")
			if theGate.Pos.x==thatMarker.Pos.x-1.5 or theGate.Pos.x==thatMarker.Pos.x+1.5 then Set(thatMarker,"LargeGate"..i,"yes") else Set(thatMarker,"LargeGate"..i,"no") end
			if Get(thatMarker,"CloseGate"..i)==nil then Set(thatMarker,"CloseGate"..i,"no") end
			if Get(thatMarker,"Authorized"..i)==nil then Set(thatMarker,"Authorized"..i,"no") end
			if Get(thatMarker,"RequestFrom"..i)==nil then Set(thatMarker,"RequestFrom"..i,"none") end
		end
	end
end

function UpdateGateModes()
	for thatMarker, d in pairs(SortedGates) do
		if Get(thatMarker,"Pos.y")~=nil then
			local tmpTooltip="\n\nAllowed traffic:\n  Cargo: "..Get(thatMarker,"CargoTraffic").."\n  Intake: "..Get(thatMarker,"IntakeTraffic").."\n  Emergency: "..Get(thatMarker,"EmgTraffic").."\n  Garage: "..Get(thatMarker,"GarageTraffic").."\n\nY positions of the gates on this lane:\n"
			for i, theGate in pairs(SortedGates[thatMarker]) do
				if Get(theGate,"Pos.y")~=nil then
					if (theGate.Mode=="LockedOpen" and theGate.Open==1) or (theGate.Mode=="LockedShut" and theGate.Open==0) and Get(thatMarker,"RequestFrom"..i)=="none" and Get(thatMarker,"Authorized"..i)=="no" then
						Set(theGate,"Mode",0)
						Set(theGate,"CloseTimer",0.1)			-- almost immediately close gate without timeout (because CloseTimer counts down from 1.000000 to 0.000000)
--						print("no traffic, closing gate")
					end
					if Get(thatMarker,"Authorized"..i)~="no" and Get(thatMarker,"CloseGate"..i)=="yes" then
						Set(theGate,"Mode",1)
						Set(theGate,"CloseTimer",0.1)
--						print("authorized, setting gate behind me to normal")
					end
					if Get(thatMarker,"RequestFrom"..i)~="none" and Get(thatMarker,"Authorized"..i)=="no" and theGate.Mode~=LockedShut then -- and theGate.Open==0 and theGate.CloseTimer==0 then
						Set(thatMarker,"Authorized"..i, Get(thatMarker,"RequestFrom"..i))
						Set(thatMarker,"RequestFrom"..i,"none")
--						print("request from "..i.." authorized")
					end
					if Get(thatMarker,"Authorized"..i)~="no" and Get(thatMarker,"CloseGate"..i)=="no" then
						Set(theGate,"Mode",2)					-- Mode 2 = LockedOpen, Mode 1 = LockedShut, Mode 0 = Close gate
				--		Set(theGate,"Open",0.1)					-- this would open the gate normally instead of setting it to LockedOpen but in this script it would do it in a loop so we don't use it here.
--						print("authorized, setting gate to lockedopen")
					end
					Set(thatMarker,"GateOpen"..i,theGate.Open)
					Set(thatMarker,"TotalGates",i)
					tmpTooltip=tmpTooltip.."\nGate "..i.." is at:  x "..theGate.Pos.x.."  y "..theGate.Pos.y.."\n  Linked: "..Get(thatMarker,"LinkGate"..i).."  Large: "..Get(thatMarker,"LargeGate"..i).."\n  Open: "..theGate.Open.."  Mode: "..theGate.Mode.."\n  CloseTimer:  "..theGate.CloseTimer.."\n  Req: "..Get(thatMarker,"RequestFrom"..i).."  Auth: "..Get(thatMarker,"Authorized"..i).."\n"
					
					theGate.Tooltip = "\n  Open: "..theGate.Open.."  Mode: "..theGate.Mode.."\n  CloseTimer:  "..theGate.CloseTimer.."\n  Req: "..Get(thatMarker,"RequestFrom"..i).."  Auth: "..Get(thatMarker,"Authorized"..i)
				else
					FindMyMarkers()		-- gate got removed, reset
					return
				end
			end
			Set(thatMarker,"Tooltip",tmpTooltip)
		else
			FindMyMarkers()				-- marker got removed or replaced, reset
			return
		end
	end
end

function CacheMyBusStops()
--	print("CacheMyBusStops starting")
	local BusStopsToSort={}
	SortedBusStops={}
	for thatMarker,d in pairs(myMarkers) do
		SortedBusStops[thatMarker]={}
--		print("searching for AllGates at "..thatIntakeMarker.Pos.x.."")
		local BusStopCounter=0
		for thatBusStop, distance in pairs(AllBusStops) do
			if thatBusStop.Pos.x==thatMarker.Pos.x-1.5000 or thatBusStop.Pos.x==thatMarker.Pos.x+1.5000 then
				BusStopCounter=BusStopCounter+1
--				print("found bus stop "..BusStopCounter.." is at "..thatBusStop.Pos.x.." "..thatBusStop.Pos.y.."  ID: "..thatBusStop.Id.u.."")
				BusStopsToSort[BusStopCounter]=thatBusStop.Pos.y
			end	
		end
		table.sort(BusStopsToSort)
		local j=0
		for i,n in ipairs(BusStopsToSort) do 
			for thatBusStop,distance in pairs(AllBusStops) do
				if thatBusStop.Pos.y==BusStopsToSort[i] and (thatBusStop.Pos.x==thatMarker.Pos.x-1.5000 or thatBusStop.Pos.x==thatMarker.Pos.x+1.5000) then
					j=j+1
--					print("sorted bus stop "..j.." is at: "..thatBusStop.Pos.x.." "..thatBusStop.Pos.y.." ID: "..thatBusStop.Id.u.."")
					SortedBusStops[thatMarker][j]=thatBusStop
				end
			end
		end
	end
	for thatMarker, d in pairs(SortedBusStops) do
		for i, theStop in pairs(SortedBusStops[thatMarker]) do
--			print("i: "..i.."   position "..theStop.Pos.x.."  "..theStop.Pos.y.."   mode "..theStop.Mode.."")
			Set(thatMarker,"BusPosX"..i,theStop.Pos.x)
			Set(thatMarker,"BusPosY"..i,theStop.Pos.y)
			Set(thatMarker,"SecLevel"..i,theStop.SecLevel)
			Set(thatMarker,"IsIntake"..i,theStop.IsIntake)
		end
	end
end

function UpdateBusStops()
	for thatMarker, d in pairs(SortedBusStops) do
		if next(SortedBusStops[thatMarker]) then
			local tmpTooltip=thatMarker.Tooltip.."\n\nY positions of the BusStops on this lane:\n"
			for i, theStop in pairs(SortedBusStops[thatMarker]) do
				if Get(theStop,"Pos.y")~=nil then
					Set(thatMarker,"BusSecLevel"..i,theStop.SecLevel)
					Set(thatMarker,"IsIntake"..i,theStop.IsIntake)
					Set(thatMarker,"TotalBusStops",i)		-- it doesn't matter when bus stops are placed and then removed. The Totals counter will make sure the bus will stop at valid points only and not obsolete ones (which are not removed from the savegame)
					if theStop.Pos.x==thatMarker.Pos.x-1.5000 then
						tmpTooltip=tmpTooltip.."\n "..i.." is at "..theStop.Pos.y.."  Unload (Left) "..theStop.SecLevel.."  To Reception "..theStop.IsIntake..""
					elseif theStop.Pos.x==thatMarker.Pos.x+1.5000 then
						tmpTooltip=tmpTooltip.."\n "..i.." is at "..theStop.Pos.y.."  Unload (Right) "..theStop.SecLevel.."  To Reception "..theStop.IsIntake..""
					else
						tmpTooltip=tmpTooltip.."\n "..i.." is at "..theStop.Pos.y.."  Invalid location"
					end
				else
				--	tmpTooltip=tmpTooltip.."\n  BusStop "..i.." has been removed, please press the Cache RoadMap button."
					FindMyMarkers()
					return
				end
			end
			Set(thatMarker,"Tooltip",tmpTooltip)
		end
	end
end

function CacheMyGarages()
--	print("CacheMyGarages starting")
	local GaragesToSort={}
	SortedGarages={}
	for thatMarker,d in pairs(myMarkers) do
		SortedGarages[thatMarker]={}
--		print("searching for AllGates at "..thatIntakeMarker.Pos.x.."")
		local GarageCounter=0
		for thatGarage, distance in pairs(AllGarages) do
			if thatGarage.ParkX==thatMarker.Pos.x then
				GarageCounter=GarageCounter+1
--				print("found Garage "..GarageCounter.." is at "..thatGarage.Pos.x.." "..thatGarage.Pos.y.."  ID: "..thatGarage.Id.u.."")
				GaragesToSort[GarageCounter]=thatGarage.ParkY
			end	
		end
		table.sort(GaragesToSort)
		local j=0
		for i,n in ipairs(GaragesToSort) do 
			for thatGarage,distance in pairs(AllGarages) do
				if thatGarage.ParkY==GaragesToSort[i] and thatGarage.ParkX==thatMarker.Pos.x then
					j=j+1
--					print("sorted Garage "..j.." is at: "..thatGarage.Pos.x.." "..thatGarage.Pos.y.." ID: "..thatGarage.Id.u.."")
					SortedGarages[thatMarker][j]=thatGarage
				end
			end
		end
	end
	for thatMarker, d in pairs(SortedGarages) do
		for i, theGarage in pairs(SortedGarages[thatMarker]) do
--			print("i: "..i.."   position "..theGarage.Pos.x.."  "..theGarage.Pos.y.."   mode "..theGarage.Mode.."")
			Set(thatMarker,"GaragePosX"..i,theGarage.ParkX)
			Set(thatMarker,"GaragePosY"..i,theGarage.ParkY)
			Set(theGarage,"MarkerUID",thatMarker.MarkerUID)
		end
	end
end

function UpdateGarages()
	for thatMarker, d in pairs(SortedGarages) do
		if next(SortedGarages[thatMarker]) then
			local tmpTooltip=thatMarker.Tooltip.."\n\nY positions of the Garages on this lane:\n"
			for i, theGarage in pairs(SortedGarages[thatMarker]) do
				if Get(theGarage,"ParkY")~=nil then
					Set(thatMarker,"TotalGarages",i)		-- it doesn't matter when bus stops are placed and then removed. The Totals counter will make sure the bus will stop at valid points only and not obsolete ones (which are not removed from the savegame)
					tmpTooltip=tmpTooltip.."\n "..i.." is at "..theGarage.ParkY..""
				else
				--	tmpTooltip=tmpTooltip.."\n  Garage "..i.." has been removed, please press the Cache RoadMap button."
					FindMyMarkers()
					return
				end
			end
			Set(thatMarker,"Tooltip",tmpTooltip)
		end
	end
end

function BuildGatesMap()
	AllSmallGates={}
	AllBigGates={}
	AllBusStops={}
	AllGarages={}
	AllSmallGates = Find(this,"SmallRoadGate",1500)
	AllBigGates = Find(this,"RoadGate",1500)
	AllBusStops = Find(this,"BusStopSign",1500)
	AllGarages = Find(this,"GantryCrane2Hook",1500)
	CacheMyGates()
	CacheMyBusStops()
	CacheMyGarages()
end

function UpdateAllGateModes()
	UpdateGateModes()
	UpdateBusStops()
	UpdateGarages()
end

function IncrimentCargo()
	--Add to count
	Set(this,"cargocount",tonumber(this.cargocount)+1)
    if this.cargocount>=this.cargoTotal then 
		Set(this,"cargocount",0)
    end
	Set(this,"IC",false)
end

function IncrimentIntake()
	--Add to count
	Set(this,"intakecount",tonumber(this.intakecount)+1)
    if this.intakecount>=this.intakeTotal then 
		Set(this,"intakecount",0)
    end
	Set(this,"II",false)
end

function IncrimentEmergency()
	--Add to count
	Set(this,"emergencycount",tonumber(this.emergencycount)+1)
    if this.emergencycount>=this.emergencyTotal then 
		Set(this,"emergencycount",0)
    end
	Set(this,"IE",false)
end

function IncrimentGarage()
	--Add to count
	Set(this,"garagecount",tonumber(this.garagecount)+1)
    if this.garagecount>=this.garageTotal then 
		Set(this,"garagecount",0)
    end
	Set(this,"IG",false)
end

function Create()
	--Initialize current markers to use
    Set(this,"cargocount",-1)
    Set(this,"intakecount",-1)
    Set(this,"emergencycount",-1)
    Set(this,"garagecount",-1)
	
	--Set totals to 0 until counted below
	Set(this,"garageTotal",0)
	Set(this,"emergencyTotal",0)
	Set(this,"intakeTotal",0)
	Set(this,"cargoTotal",0)
	
	--Incriment functions
    IncrimentCargo()
    IncrimentIntake()
    IncrimentEmergency()
    IncrimentGarage()
	
	--Trigger variables for incriment functions
    Set(this,"IC",false)
	Set(this,"II",false)
	Set(this,"IE",false)
	Set(this,"IG",false)
	Set(this,"FindNewMarkers",false)
end

function FindMyMarkers()
	print("Updating markers and gates")
	myMarkers=Find(this,"RoadMarker",1500)
	BuildGatesMap()
	UpdateAllGateModes()
end

function findMarkersClicked()
	FindMyMarkers()
end

function ResetRoadMarker(MarkerToReset)
	for i=1,10 do
		Set(MarkerToReset,"GatePosY"..i,0)
	--	Set(MarkerToReset,"GateOpen"..i,0)					-- enabling all these might give unforseen problems for user when vehicles are on the map, 
	--	Set(MarkerToReset,"CloseGate"..i,"no")				-- so if he needs a REAL reset, then just press Reset button on the marker itself
	--	Set(MarkerToReset,"LinkGate"..i,"no")
	--	Set(MarkerToReset,"RequestFrom"..i,"none")
	--	Set(MarkerToReset,"Authorized"..i,"no")
	end
	Set(MarkerToReset,"TotalGates",0)
end

function Update(TimePassed)
	if timeMax==nil then
		if this.FindNewMarkers == nil then this.Delete() end
		if this.garagecount==nil then this.Delete() end
		if this.Pos.y~=0 then this.Pos.y=0 end
		Set(this,"Tooltip","tooltip_streetmanager")
		Interface.AddComponent( this,"findMarkers", "Button", "Update road map")
		FindMyMarkers()
		timeMax=1
	end
    timeTot = timeTot + TimePassed
    if timeTot>timeMax then
        timeTot=0
		if this.Pos.y~=0.5 then this.Pos.y=0.5 end		-- zap to top of map if it was expanded to the north
		
		if Get(this,"FindNewMarkers") == true then
			Set(this,"FindNewMarkers",false)
			FindMyMarkers()
		end
		
		UpdateAllGateModes()
		
		if Get(this,"IC")==true then
			IncrimentCargo()
			local currentCargoID = 0
			for n,d in pairs(myMarkers) do
				if Get(n,"CargoTraffic")=="yes" then
					Set(n,"CargoMarkerID",currentCargoID)
					currentCargoID = currentCargoID + 1
				end
			end
			Set(this,"cargoTotal",currentCargoID)
		end

		if Get(this,"II")==true then
			IncrimentIntake()
			local currentIntakeID = 0
			for n,d in pairs(myMarkers) do
				if Get(n,"IntakeTraffic")=="yes" then
					Set(n,"IntakeMarkerID",currentIntakeID)
					currentIntakeID = currentIntakeID + 1
				end
			end
			Set(this,"intakeTotal",currentIntakeID)
		end

		if Get(this,"IE")==true then
			IncrimentEmergency()
			local currentEmgID = 0
			for n,d in pairs(myMarkers) do
				if Get(n,"EmgTraffic")=="yes" then
					Set(n,"EmergencyMarkerID",currentEmgID)
					currentEmgID = currentEmgID + 1
				end
			end
			Set(this,"emergencyTotal",currentEmgID)
		end
		
		if Get(this,"IG")==true then
			IncrimentGarage()
			local currentGarID = 0
			for n,d in pairs(myMarkers) do
				if Get(n,"GarageTraffic")=="yes" then
					Set(n,"GarageMarkerID",currentGarID)
					currentGarID = currentGarID + 1
				end
			end
			Set(this,"garageTotal",currentGarID)
		end
	end
end
