
--    Name                 TowTruck  
--    Height               8  
--    SpriteScale          1.2
local randomUpdateTimer = 0
local timeTot=0
local blinkTimer = 0
local Get = Object.GetProperty
local Set = Object.SetProperty
local Find = Object.GetNearbyObjects
local MyMarker={}
local NeighbourMarkerLeft={}
local NeighbourMarkerRight={}
local MarkerFound=false
local nextGarageFound=false
local ThisIsMyGarage = false
local NewEngine1 = {}
local NewEngine2 = {}
local NewLimo1 = {}
local NewLimo2 = {}
local nearbyObject = {}
local Limo2RepairOrderPapersNr = 0

function FindMyRoadMarker()
	--print("FindMyRoadMarker")
    local nearbyObject = Find(this,"RoadMarker",1500)
	if next(nearbyObject) then
		for thatMarker,dist in pairs(nearbyObject) do
			if thatMarker.Pos.x >= this.Pos.x-3 and thatMarker.Pos.x <= this.Pos.x+3 then
				MyMarker=thatMarker
				Set(this,"MarkerUID",Get(thatMarker,"MarkerUID"))
				MarkerFound = true
				--print("marker found")
				break
			end
		end
	end
	nearbyObject = nil
end

function FindMapEdge()
	--print("FindMapEdge")
	local endY=-1
	local foundEndY=false
	
	while foundEndY==false do
		endY=endY+1
		local myCell = World.GetCell(this.Pos.x,endY)
		if myCell.Mat==nil then
			foundEndY=true
			endY=endY-1
		end
	end
	Set("MapBottom",endY)
end

function FindMyCrane()
	--print("findmygarage")
	local nearbyObject = Find("GantryCrane2Booth",1500)
	if next(nearbyObject) then
		for thatBooth, distance in pairs(nearbyObject) do
			if thatBooth.HomeUID==this.CraneUID then
				MyCraneBooth=thatBooth
				--print("booth found")
				break
			end
		end
	end
	nearbyObject = nil
end

function FindMyTrafficLight()
	local roadFound = false
	local nearbyObject = Find("RoadPoleTrafficLight",1500)
	if next(nearbyObject) then
		for thatLight, distance in pairs(nearbyObject) do
			if thatLight.HomeUID==this.CraneUID then
				if thatLight.SideLaneLight == true then
					print("SideLaneTrafficLight found")
					MySideLaneTrafficLight=thatLight
					sideFound = true
				end
			end
		end
	end
	nearbyObject = nil
end

function UpdateFollowUps()
	--print("UpdateFollowUps")
	Set(this,"FollowUpID",-1)
	Set(this,"FollowingID",nil)
	if MyVehicleInFront ~= nil and MyVehicleInFront.SubType ~= nil then
		if MyVehicleBehind ~= nil and MyVehicleBehind.SubType ~= nil then
			Set(MyVehicleBehind,"VehicleTypeInFront",MyVehicleInFront.Type)
			Set(MyVehicleBehind,"DistanceInFront",(this.Pos.y - MyVehicleBehind.Pos.y) + (MyVehicleInFront.Pos.y - this.Pos.y) + 5)
			Set(MyVehicleInFront,"VehicleTypeBehind",MyVehicleBehind.Type)
			Set(MyVehicleInFront,"DistanceBehind",(this.Pos.y - MyVehicleBehind.Pos.y) + (MyVehicleInFront.Pos.y - this.Pos.y) + 5)
			Set(MyVehicleInFront,"FollowUpID",MyVehicleBehind.Id.i)
			Set(MyVehicleBehind,"FollowingID",MyVehicleInFront.Id.i)
			Set(MyVehicleInFront,"UpdateVehicleBehind",true)
			Set(MyVehicleBehind,"UpdateVehicleInFront",true)
		else
			Set(MyVehicleInFront,"VehicleTypeBehind","None")
			Set(MyVehicleInFront,"FollowUpID",-1)
			Set(MyVehicleInFront,"UpdateVehicleBehind",true)
		end
	else
		if MyVehicleBehind ~= nil and MyVehicleBehind.SubType ~= nil then
			Set(MyVehicleBehind,"VehicleTypeInFront","None")
			Set(MyVehicleBehind,"FollowingID",-1)
			Set(MyVehicleBehind,"UpdateVehicleInFront",true)
		end
	end
	MyVehicleInFront = nil
	MyVehicleBehind = nil
	VehicleTailLights = nil
end

function FindVehicleBehindMe()
	--print("FindVehicleBehindMe")
	local CurrDist = 9999
	local tmpMyVehicleBehind = nil
	local group = {"TowTruck2WithLimo","TowTruck2WithCarParts","Limo2"}
	for _, typ in pairs(group) do
		local nearbyObject = Find(typ,500)
		for V, distance in pairs(nearbyObject) do
			if V.Id.i ~= this.Id.i and V.VehicleState ~= "Processing" and V.VehicleState ~= "EnteringGarage" and V.Pos.x >= this.Pos.x-3 and V.Pos.x <= this.Pos.x+3 and V.Pos.y < this.Pos.y-8 and this.Pos.y-V.Pos.y < CurrDist then
				CurrDist = distance
				tmpMyVehicleBehind=V
				--print("My x: "..this.Pos.x.."  My y: "..this.Pos.y.."   "..V.HomeUID.." found behind me at x: "..V.Pos.x.." y: "..V.Pos.y.." Dist: "..CurrDist)
			end
		end
	end
	nearbyObject=nil
	if tmpMyVehicleBehind ~= nil and tmpMyVehicleBehind.SubType ~= nil then
		MyVehicleBehind = tmpMyVehicleBehind
		Set(MyVehicleBehind,"VehicleTypeInFront",this.Type)
		Set(MyVehicleBehind,"DistanceInFront",CurrDist+5)
		Set(MyVehicleBehind,"FollowingID",this.Id.i)
		Set(this,"FollowUpID",MyVehicleBehind.Id.i)
		Set(MyVehicleBehind,"UpdateVehicleInFront",true)
		VehicleHeadLights = MyVehicleBehind.Pos.y + MyVehicleBehind.Head
		--print("MyVehicleBehind is "..MyVehicleBehind.HomeUID)
	else
		MyVehicleBehind = nil
	end
end

function FindVehicleInFront()
	--print("FindVehicleInFront")
	local CurrDist = 9999
	local tmpMyVehicleInFront = nil
	local group = {"TowTruck2WithLimo","TowTruck2WithCarParts","Limo2"}
	for _, typ in pairs(group) do
		local nearbyObject = Find(typ,500)
		for V, distance in pairs(nearbyObject) do
			if V.Pos.x ~= nil and V.Id.i ~= this.Id.i and V.VehicleState ~= "Processing" and V.VehicleState ~= "EnteringGarage" and V.Pos.x >= this.Pos.x-3 and V.Pos.x <= this.Pos.x+3 and V.Pos.y >= this.Pos.y-8 and V.Pos.y-this.Pos.y < CurrDist then
				if this.VehicleState == "LeavingGarage" then
					CurrDist = distance
					tmpMyVehicleInFront=V
					--print("My x: "..this.Pos.x.."  My y: "..this.Pos.y.."   "..V.HomeUID.." found in front at x: "..V.Pos.x.." y: "..V.Pos.y.." Dist: "..CurrDist)
				elseif V.FollowUpID == -1 then
					CurrDist = distance
					tmpMyVehicleInFront=V
					--print("My x: "..this.Pos.x.."  My y: "..this.Pos.y.."   "..V.HomeUID.." found in front at x: "..V.Pos.x.." y: "..V.Pos.y.." Dist: "..CurrDist)
				end
			end
		end
	end
	nearbyObject=nil
	if tmpMyVehicleInFront ~= nil and tmpMyVehicleInFront.SubType ~= nil then
		MyVehicleInFront = tmpMyVehicleInFront
		Set(MyVehicleInFront,"VehicleTypeBehind",this.Type)
		Set(MyVehicleInFront,"DistanceBehind",CurrDist+5)
		Set(MyVehicleInFront,"FollowUpID",this.Id.i)
		Set(this,"FollowingID",MyVehicleInFront.Id.i)
		Set(MyVehicleInFront,"UpdateVehicleBehind",true)
		VehicleTailLights = MyVehicleInFront.Pos.y - MyVehicleInFront.Tail
		--print("MyVehicleInFront is "..MyVehicleInFront.HomeUID)
	else
		MyVehicleInFront = nil
	end
end

function LoadVehicleBehindMe()
	--print("LoadVehicleBehind")
	local vFound = false
	if this.VehicleTypeBehind ~= "None" then
		--print("trying to find"..this.VehicleTypeBehind.." at distance "..this.DistanceBehind)
		local vehicles = Find(this.VehicleTypeBehind,this.DistanceBehind)
		for V, _ in pairs(vehicles) do
			if Get(V,"FollowingID") == this.Id.i and this.FollowUpID == V.Id.i then --and V.VehicleState ~= "Processing" and V.VehicleState ~= "EnteringGarage" then
				tmpMyVehicleBehind=V
				vFound = true
				break
			end
		end
		vehicles=nil
	end
	if vFound == true then
		MyVehicleBehind = tmpMyVehicleBehind
		VehicleHeadLights = MyVehicleBehind.Pos.y + MyVehicleBehind.Head
		--print("MyVehicleBehind is "..MyVehicleBehind.HomeUID)
	else
		MyVehicleBehind = nil
		--print("MyVehicleBehind not found")
		FindVehicleBehindMe()
	end
end

function LoadVehicleInFront()
	--print("LoadVehicleInFront")
	local vFound = false
	if this.VehicleTypeInFront ~= "None" then
		--print("trying to find"..this.VehicleTypeInFront.." at distance "..this.DistanceInFront)
		local vehicles = Find(this.VehicleTypeInFront,this.DistanceInFront)
		for V, _ in pairs(vehicles) do
			if Get(V,"FollowUpID") == this.Id.i and this.FollowingID == V.Id.i then --and V.VehicleState ~= "Processing" and V.VehicleState ~= "EnteringGarage" then
				tmpMyVehicleInFront=V
				vFound = true
				break
			end
		end
		vehicles=nil
	end
	if vFound == true then
		MyVehicleInFront = tmpMyVehicleInFront
		VehicleTailLights = MyVehicleInFront.Pos.y - MyVehicleInFront.Tail
		--print("MyVehicleInFront is "..MyVehicleInFront.HomeUID)
	else
		MyVehicleInFront = nil
		--print("MyVehicleInFront not found")
		FindVehicleInFront()
	end
end

function FindMyCargo()
	--print("FindMyCargo")
	nearbyObject = Find("Limo2Engine",5)
	if next(nearbyObject) then
		for thatEngine, distance in pairs(nearbyObject) do
			if Get(thatEngine,"Id.i") == Get(this,"Slot0.i") then
				NewEngine1 = thatEngine
				--print("engine1 found")
			elseif Get(thatEngine,"Id.i") == Get(this,"Slot1.i") then
				NewEngine2 = thatEngine
				--print("engine2 found")
			end
		end
	end
	nearbyObject = Find("Limo2Broken",5)
	if next(nearbyObject) then
		for thatCar, distance in pairs(nearbyObject) do
			if Get(thatCar,"Id.i") == Get(this,"Slot0.i") then
				NewLimo1 = thatCar
				--print("limo1 found")
			elseif Get(thatCar,"Id.i") == Get(this,"Slot1.i") then
				NewLimo2 = thatCar
				--print("limo2 found")
			end
		end
	end
	nearbyObject = nil
end

function FindMyUnloadedCargo()
	--print("FindMyUnloadedCargo")
	nearbyObject = Find("Limo2Engine",5)
	if next(nearbyObject) then
		for thatEngine, distance in pairs(nearbyObject) do
			if Get(thatEngine,"Id.i") == Get(this,"UnloadedEngine1ID") then
				NewEngine1 = thatEngine
				Set(this,"Slot0.i",NewEngine1.Id.i)
				Set(this,"Slot0.u",NewEngine1.Id.u)
				Set(NewEngine1,"CarrierId.i",this.Id.i)
				Set(NewEngine1,"CarrierId.u",this.Id.u)
				NewEngine1.Loaded = true
				--print("engine1 found")
			elseif Get(thatEngine,"Id.i") == Get(this,"UnloadedEngine2ID") then
				NewEngine2 = thatEngine
				Set(this,"Slot1.i",NewEngine2.Id.i)
				Set(this,"Slot1.u",NewEngine2.Id.u)
				Set(NewEngine2,"CarrierId.i",this.Id.i)
				Set(NewEngine2,"CarrierId.u",this.Id.u)
				NewEngine2.Loaded = true
				--print("engine2 found")
			end
		end
	end
	nearbyObject = Find("Limo2Broken",5)
	if next(nearbyObject) then
		for thatCar, distance in pairs(nearbyObject) do
			if Get(thatCar,"Id.i") == Get(this,"UnloadedLimo1ID") then
				NewLimo1 = thatCar
				Set(this,"Slot0.i",NewLimo1.Id.i)
				Set(this,"Slot0.u",NewLimo1.Id.u)
				Set(NewLimo1,"CarrierId.i",this.Id.i)
				Set(NewLimo1,"CarrierId.u",this.Id.u)
				NewLimo1.Loaded = true
				--print("limo1 found")
			elseif Get(thatCar,"Id.i") == Get(this,"UnloadedLimo2ID") then
				NewLimo2 = thatCar
				Set(this,"Slot1.i",NewLimo2.Id.i)
				Set(this,"Slot1.u",NewLimo2.Id.u)
				Set(NewLimo2,"CarrierId.i",this.Id.i)
				Set(NewLimo2,"CarrierId.u",this.Id.u)
				NewLimo2.Loaded = true
				--print("limo2 found")
			end
		end
	end
	nearbyObject = nil
end

function DeleteMyCargo()
	--print("DeleteMyCargo")
	nearbyObject = Find("Limo2Engine",5)
	if next(nearbyObject) then
		for thatEngine, distance in pairs(nearbyObject) do
			if Get(thatEngine,"Id.i") == Get(this,"Slot0.i") then
				thatEngine.Delete()
				--print("engine1 deleted")
			elseif Get(thatEngine,"Id.i") == Get(this,"Slot1.i") then
				thatEngine.Delete()
				--print("engine2 deleted")
			end
		end
	end
	nearbyObject = Find("Limo2Broken",5)
	if next(nearbyObject) then
		for thatCar, distance in pairs(nearbyObject) do
			if Get(thatCar,"Id.i") == Get(this,"Slot0.i") then
				thatCar.Delete()
				--print("limo1 deleted")
			elseif Get(thatCar,"Id.i") == Get(this,"Slot1.i") then
				thatCar.Delete()
				--print("limo2 deleted")
			end
		end
	end
	nearbyObject = nil
end

function FindStackNumber()
	--print("FindStackNumber")
	local newStack = Object.Spawn("Stack", this.Pos.x-1, this.Pos.y)
	for i = 1,2000 do
		Set(newStack,"Quantity",2)
		Set(newStack,"Contents",i)
		if newStack.Contents == "Limo2RepairOrderPapers" then
			Limo2RepairOrderPapersNr = i
		end
		if Limo2RepairOrderPapersNr > 1 then
			newStack.Delete()
			--print("Stack Limo2RepairOrderPapers: "..Limo2RepairOrderPapersNr)
			break
		end
	end
end

function WaitForGarage()
	--print("WaitForGarage")
	this.VehicleState = "Processing"
	this.VelY = 0
	this.Tooltip="\nVehicle ID: "..this.HomeUID.."\nCrane ID: "..this.CraneUID.."\n\nStatus: Processing\n\nVehicle behind me: None\nVehicle in front: None"
	if not Get(this,"DriverSpawned") then
		--print("Spawn driver and unload")
		CloseGatesBehindMe(true)
		Set(MyMarker,"RequestFrom"..this.GateCount-1,"none")
		Set(MyMarker,"Authorized"..this.GateCount-1,"no")
		Set(MyMarker,"CloseGate"..this.GateCount-1,"no")
		if MyCraneBooth.IsMilitary == "Yes" then
			myTruckDriver = Object.Spawn("TowTruck2DriverMilitary",this.Pos.x,this.Pos.y+5.5)
		else
			myTruckDriver = Object.Spawn("TowTruck2Driver",this.Pos.x,this.Pos.y+5.5)
		end
		Set(myTruckDriver,"HomeUID",Get(this,"CraneUID"))
		Set(myTruckDriver,"TruckID",this.Id.i)
		Set(this,"DriverSpawned",true)
	
		if Get(this,"PartsSpawned") == true then		-- car engines on truck
			if Get(MyCraneBooth,"PartsRackIsFull") == false then
				if NewEngine1.Loaded == nil and NewEngine2.Loaded == nil then FindMyCargo() end	-- find them after loadgame
				if NewEngine1.Loaded == nil and NewEngine2.Loaded == nil then Set(this,"PartsOnTruck",false) else Set(this,"PartsOnTruck",true) end
			end
				
			if Get(this,"PartsOnTruck") == true and Get(MyCraneBooth,"PartsRackIsFull") == false then
				
				if NewEngine1 ~= nil and NewEngine1.SubType ~= nil and NewEngine1.Loaded then
					Set(this,"UnloadedEngine1ID",NewEngine1.Id.i)
					Set(this,"Slot0.i",-1)
					Set(this,"Slot0.u",-1)
					NewEngine1.Loaded = false
					Set(MyCraneBooth,"Truck0X",NewEngine1.Pos.x)
					Set(MyCraneBooth,"Truck0Y",NewEngine1.Pos.y-0.85)
					Set(MyCraneBooth,"UnloadEngineSlot0",true)
				end
				if NewEngine2 ~= nil and NewEngine2.SubType ~= nil and NewEngine2.Loaded then
					Set(this,"UnloadedEngine2ID",NewEngine2.Id.i)
					Set(this,"Slot1.i",-1)
					Set(this,"Slot1.u",-1)
					NewEngine2.Loaded = false
					Set(MyCraneBooth,"Truck1X",NewEngine2.Pos.x)
					Set(MyCraneBooth,"Truck1Y",NewEngine2.Pos.y-0.85)
					Set(MyCraneBooth,"UnloadEngineSlot1",true)
				end
			end
		
		elseif Get(this,"LimoSpawned") == true then										-- limos on truck
			if Get(MyCraneBooth,"GarageIsFull") == false then
				if NewLimo1.Loaded == nil and NewLimo2.Loaded == nil then FindMyCargo() end		-- find them after loadgame
				if NewLimo1.Loaded == nil and NewLimo2.Loaded == nil then Set(this,"CarOnTruck",false) else Set(this,"CarOnTruck",true) end
			end
				
			if Get(this,"CarOnTruck") == true and Get(MyCraneBooth,"GarageIsFull") == false then
				
				if NewLimo1 ~= nil and NewLimo1.SubType ~= nil and NewLimo1.Loaded then
					Set(this,"UnloadedLimo1ID",NewLimo1.Id.i)
					Set(this,"Slot0.i",-1)
					Set(this,"Slot0.u",-1)
					NewLimo1.Loaded = false
					Set(NewLimo1,"GateCount",Get(this,"GateCount"))
					Set(MyCraneBooth,"Truck0X",NewLimo1.Pos.x)
					Set(MyCraneBooth,"Truck0Y",NewLimo1.Pos.y-0.75)
					Set(MyCraneBooth,"UnloadTruckSlot0",true)
				end
				if NewLimo2 ~= nil and NewLimo2.SubType ~= nil and NewLimo2.Loaded then
					Set(this,"UnloadedLimo2ID",NewLimo2.Id.i)
					Set(this,"Slot1.i",-1)
					Set(this,"Slot1.u",-1)
					NewLimo2.Loaded = false
					Set(NewLimo2,"GateCount",Get(this,"GateCount"))
					Set(MyCraneBooth,"Truck1X",NewLimo2.Pos.x)
					Set(MyCraneBooth,"Truck1Y",NewLimo2.Pos.y-0.75)
					Set(MyCraneBooth,"UnloadTruckSlot1",true)
				end
			end
		end
	end
end

function WaitForGateToOpen()
	--print("WaitForGateToOpen")
	if Get(this,"GateCount")<=Get(MyMarker,"TotalGates") then
		if Get(MyMarker,"Authorized"..this.GateCount) ~= this.HomeUID then
			if Get(MyMarker,"GatePosY"..this.GateCount) - MyHeadLights <= 1 or (Get(MyMarker,"LargeGate"..this.GateCount)=="yes" and Get(MyMarker,"GatePosY"..this.GateCount)-MyHeadLights <= 1.5) then
				this.VelY = 0
				if Get(MyMarker,"RequestFrom"..this.GateCount) == "none" then
					Set(MyMarker,"RequestFrom"..this.GateCount,this.HomeUID)
					if Get(MyMarker,"LargeGate"..this.GateCount)=="yes" then
						if Get(MyMarker,"GatePosX"..this.GateCount)==this.Pos.x+1.5 and next(NeighbourMarkerRight) then
							Set(NeighbourMarkerRight,"RequestFrom"..this.GateCount,this.HomeUID)
						elseif Get(MyMarker,"GatePosX"..this.GateCount)==this.Pos.x-1.5 and next(NeighbourMarkerLeft) then
							Set(NeighbourMarkerLeft,"RequestFrom"..this.GateCount,this.HomeUID)
						end
					end
				end
				if Get(MyMarker,"LinkGate"..this.GateCount) ~= "no" then
					for j=1,Get(MyMarker,"TotalGates") do
						if Get(MyMarker,"LinkGate"..j)==Get(MyMarker,"LinkGate"..this.GateCount) and Get(MyMarker,"RequestFrom"..j) == "none" then
							Set(MyMarker,"RequestFrom"..j,this.HomeUID)
							if Get(MyMarker,"LargeGate"..j)=="yes" then
								if Get(MyMarker,"GatePosX"..j)==this.Pos.x+1.5 and next(NeighbourMarkerRight) then
									Set(NeighbourMarkerRight,"RequestFrom"..j,this.HomeUID)
								elseif Get(MyMarker,"GatePosX"..j)==this.Pos.x-1.5 and next(NeighbourMarkerLeft) then
									Set(NeighbourMarkerLeft,"RequestFrom"..j,this.HomeUID)
								end
							end
						end
					end
				end
			end
		end
		if Get(MyMarker,"LinkGate"..this.GateCount)=="no" then
			if Get(MyMarker,"Authorized"..this.GateCount)==this.HomeUID and Get(MyMarker,"GateOpen"..this.GateCount)==1 then
				Set(this,"GateCount",this.GateCount+1)
			end
		else
			if Get(MyMarker,"GatePosY"..this.GateCount) - MyHeadLights <= 4 then
				local gatesopencounter=0
				local linkedgatescounter=0
				for j=1,Get(MyMarker,"TotalGates") do
					if Get(MyMarker,"LinkGate"..j)==Get(MyMarker,"LinkGate"..this.GateCount) then
						linkedgatescounter=linkedgatescounter+1
						if (Get(MyMarker,"Authorized"..j)==this.HomeUID and Get(MyMarker,"GateOpen"..j)==1) or (Get(MyMarker,"Authorized"..j)~="none" and Get(MyMarker,"GateOpen"..j)==1 and Get(MyMarker,"LargeGate"..this.GateCount)=="yes") then
							gatesopencounter=gatesopencounter+1
						end
					end
				end
				if gatesopencounter==linkedgatescounter then
					Set(this,"GateCount",this.GateCount+linkedgatescounter)
				else
					this.VelY = 0
				end
			end
		end
	end
end

function CloseGatesBehindMe(forced)
	--print("CloseGatesBehindMe")
	for i=1,this.GateCount do
		if Get(MyMarker,"Authorized"..i)==this.HomeUID then
			--print(MyTailLights-Get(MyMarker,"GatePosY"..i))
			if MyTailLights-Get(MyMarker,"GatePosY"..i) > 0 then
				--print("Authorized"..i.." is "..MyTailLights-Get(MyMarker,"GatePosY"..i).." behind me, Closing gate"..i)
				Set(MyMarker,"CloseGate"..i,"yes")
				if Get(MyMarker,"LargeGate"..i)=="yes" then
					if Get(MyMarker,"GatePosX"..i)==this.Pos.x+1.5 and next(NeighbourMarkerRight) then
						Set(NeighbourMarkerRight,"CloseGate"..i,"yes")
					elseif Get(MyMarker,"GatePosX"..i)==this.Pos.x-1.5 and next(NeighbourMarkerLeft) then
						Set(NeighbourMarkerLeft,"CloseGate"..i,"yes")
					end
				end
			end
			if MyTailLights-Get(MyMarker,"GatePosY"..i) > 3 or forced then 
				for j=1,this.GateCount do
					if Get(MyMarker,"LinkGate"..j)==Get(MyMarker,"LinkGate"..i) then
						--print("Authorized"..i.." is "..MyTailLights-Get(MyMarker,"GatePosY"..i).." behind me, Clear gate"..i)
						Set(MyMarker,"Authorized"..i,"no")
						Set(MyMarker,"CloseGate"..i,"no")
						if Get(MyMarker,"LargeGate"..i)=="yes" then
							if Get(MyMarker,"GatePosX"..i)==this.Pos.x+1.5 and next(NeighbourMarkerRight) then
								Set(NeighbourMarkerRight,"Authorized"..i,"no")
								Set(NeighbourMarkerRight,"CloseGate"..i,"no")
							elseif Get(MyMarker,"GatePosX"..i)==this.Pos.x-1.5 and next(NeighbourMarkerLeft) then
								Set(NeighbourMarkerLeft,"Authorized"..i,"no")
								Set(NeighbourMarkerLeft,"CloseGate"..i,"no")
							end
						end
					end
				end
			end
		end
	end
end

function Create()
	Set(this,"Tail",4.5)
	Set(this,"Head",4.75)
	Set(this,"HomeUID","TowTruck_"..me["id-uniqueId"])
	Set(this,"GateCount",1)
	Set(this,"GarageCount",0)
	Set(this,"LimoSpawned",false)
	Set(this,"PartsSpawned",false)
	Set(this,"nextGarageFound",false)
	Set(this,"OrderAmount",0)
	Set(this,"VehicleState","Arriving")
	Set(this,"UpdateVehicleBehind",false)
	Set(this,"DistanceBehind",0)
	Set(this,"VehicleTypeBehind","None")
	Set(this,"UpdateVehicleInFront",false)
	Set(this,"DistanceInFront",0)
	Set(this,"VehicleTypeInFront","None")
	Set(this,"VelX",0)
	Set(this,"VelY",0)
	Set(this,"FollowingID",-1)
	Set(this,"FollowUpID",-1)
end

function DeleteTruckClicked()
	CloseGatesBehindMe()
	Interface.RemoveComponent(this,"SeparatorTruck")
	Interface.RemoveComponent(this,"DeleteVehicle")
	Interface.RemoveComponent(this,"TransferDelivery")
	this.Delete()
end

function BlinkLight()
	if blinkTimer > 0.25 then
		blinkTimer = 0
		if this.VehicleState == "EnteringGarage" then
			if MyCraneBooth.GaragePlacement == "Right" or MyCraneBooth.GaragePlacement == "Centre" then
				if MyCraneBooth.IsMilitary == "No" then
					if this.SubType == 0 then this.SubType = 3 else this.SubType = 0 end
				else
					if this.SubType == 1 then this.SubType = 5 else this.SubType = 1 end
				end
			elseif MyCraneBooth.GaragePlacement == "Left" then
				if MyCraneBooth.IsMilitary == "No" then
					if this.SubType == 0 then this.SubType = 4 else this.SubType = 0 end
				else
					if this.SubType == 1 then this.SubType = 6 else this.SubType = 1 end
				end
			end
		else
			if MyCraneBooth.GaragePlacement == "Right" or MyCraneBooth.GaragePlacement == "Centre" then
				if MyCraneBooth.IsMilitary == "No" then
					if this.SubType == 0 then this.SubType = 4 else this.SubType = 0 end
				else
					if this.SubType == 1 then this.SubType = 6 else this.SubType = 1 end
				end
			elseif MyCraneBooth.GaragePlacement == "Left" then
				if MyCraneBooth.IsMilitary == "No" then
					if this.SubType == 0 then this.SubType = 3 else this.SubType = 0 end
				else
					if this.SubType == 1 then this.SubType = 5 else this.SubType = 1 end
				end
			end
		end
	end
end

function TurnIn()
	--print("TurnIn")
	if MyCraneBooth.GaragePlacement == "Left" and MyCraneBooth.TruckParkX > this.Pos.x then
		this.VelX = 1.25
		this.VelY = 1.85
	elseif MyCraneBooth.GaragePlacement == "Right" and MyCraneBooth.TruckParkX < this.Pos.x then
		this.VelX = -1.25
		this.VelY = 1.85
	elseif MyCraneBooth.GaragePlacement == "Centre" and MyCraneBooth.TruckParkX < this.Pos.x then
		this.VelX = -1.25
		this.VelY = 1.85
	else
		this.VelX = 0
		this.VelY = 0
		WaitForGarage()
		if MyCraneBooth.IsMilitary == "No" then
			this.SubType = 0
		else
			this.SubType = 1
		end 
		timePerUpdate = 5
	end
end

function TurnOut()
	--print("TurnOut")
	if MyCraneBooth.GaragePlacement == "Left" and MyCraneBooth.RoadX < this.Pos.x-0.1 then
		this.VelX = -1.25
		this.VelY = 1.85
	elseif MyCraneBooth.GaragePlacement == "Right" and MyCraneBooth.RoadX > this.Pos.x+0.1 then
		this.VelX = 1.25
		this.VelY = 1.85
	elseif MyCraneBooth.GaragePlacement == "Centre" and MyCraneBooth.RoadX > this.Pos.x+0.1 then
		this.VelX = 1.25
		this.VelY = 1.85
	else
		--print("leaving")
		Set(this,"GateCount",this.GateCount+1)
		this.VelX = 0
		this.VelY = 1.5
		this.Pos.x = MyCraneBooth.RoadX
		this.VehicleState = "Leaving"
		if MyCraneBooth.IsMilitary == "No" then
			this.SubType = 0
		else
			this.SubType = 1
		end
	end
end

function Drive()
	timePerUpdate = 0.2
	if this.VelY < 2 then
		this.VelY = this.VelY+0.5
	end
	if MyMarker ~= nil and MyMarker.TotalGates ~= nil then CloseGatesBehindMe() end
	if MyMarker ~= nil and MyMarker.TotalGates ~= nil and MyMarker.TotalGates >= this.GateCount and Get(MyMarker,"RequestFrom"..this.GateCount)~=this.HomeUID and (Get(MyMarker,"GatePosY"..this.GateCount) - MyHeadLights <= 1 or (Get(MyMarker,"LargeGate"..this.GateCount)=="yes" and Get(MyMarker,"GatePosY"..this.GateCount)-MyHeadLights <= 1.5)) then
		timePerUpdate = 1
		WaitForGateToOpen()
	elseif MyVehicleInFront ~= nil and MyVehicleInFront.SubType ~= nil and VehicleTailLights - MyHeadLights <= 3 then
		timePerUpdate = 0
		this.VelY = VehicleTailLights - MyHeadLights - 0.5			-- - 1.8
		if this.VelY < 0.01 then
			this.VelY = 0
			timePerUpdate = 1
		end
	else
		if MyMarker ~= nil and MyMarker.TotalGates ~= nil and MyMarker.TotalGates >= this.GateCount and Get(MyMarker,"GatePosY"..this.GateCount) - MyHeadLights <= 3 then
			timePerUpdate = 0
		--	if Get(MyMarker,"LargeGate"..this.GateCount)=="yes" then
		--		this.VelY = (Get(MyMarker,"GatePosY"..this.GateCount) - MyHeadLights)-- - 2.3
		--	else
				this.VelY = (Get(MyMarker,"GatePosY"..this.GateCount) - MyHeadLights) - 0.5			-- - 1.8
		--	end
		else
			timePerUpdate = 0.2	
			if this.VelY < 3 then
				this.VelY = this.VelY+0.1
			end
		end
	end
end

function Init()
	Interface.AddComponent(this,"SeparatorTruck", "Caption", "tooltip_separatorline")
	Interface.AddComponent(this,"DeleteTruck", "Button", "Delete")
	if Get(this,"CraneUID")==nil then
		Set(this,"CraneUID",0)
	end
	if Get(this,"VelY")==nil then
		Set(this,"VelX",0)
		Set(this,"VelY",0)
	end
	FindMyRoadMarker()
	FindMapEdge()
	FindMyCrane()
	FindMyTrafficLight()
	if this.VehicleState ~= "Processing" then
		if Get(this,"FollowingID") == -1 then
			FindVehicleInFront()
		else
			LoadVehicleInFront()
		end
		if Get(this,"FollowUpID") == -1 then
			FindVehicleBehindMe()
		else
			LoadVehicleBehindMe()
		end
	end
	local timerOk = false
	while timerOk == false do
		randomUpdateTimer = math.random()
		if randomUpdateTimer > 0.2 and randomUpdateTimer < 0.4 then
			timerOk = true
		end
	end
	timePerUpdate=randomUpdateTimer
end

function Update(timePassed)
	if timePerUpdate==nil then
		Init()
	end
	timeTot=timeTot+timePassed
	blinkTimer = blinkTimer+timePassed
	if timeTot>=timePerUpdate then
		timeTot=0
		
		if Get(this,"UpdateVehicleBehind") == true then
			LoadVehicleBehindMe()
			Set(this,"UpdateVehicleBehind",false)
		end
		if Get(this,"UpdateVehicleInFront") == true then
			LoadVehicleInFront()
			Set(this,"UpdateVehicleInFront",false)
		end
		
		MyTailLights = this.Pos.y - this.Tail
		MyHeadLights = this.Pos.y + this.Head
		if MyVehicleBehind ~= nil and MyVehicleBehind.SubType ~= nil then
			VehicleHeadLights = MyVehicleBehind.Pos.y + MyVehicleBehind.Head
		end
		if MyVehicleInFront ~= nil and MyVehicleInFront.SubType ~= nil then
			VehicleTailLights = MyVehicleInFront.Pos.y - MyVehicleInFront.Tail
		end
		
		if this.VehicleState=="Arriving" or this.VehicleState == "EnteringGarage" or this.VehicleState=="LeavingGarage" or this.VehicleState=="Leaving" then
			if this.VehicleState == "Arriving" then
				if MyCraneBooth.TruckParkY-MyHeadLights <= 0 then
					this.VehicleState = "EnteringGarage"
					if not Get(this,"VehiclesUpdated") then
						UpdateFollowUps()
						Set(this,"VehiclesUpdated",true)
					end
				else
					Drive()
				end
			elseif this.VehicleState == "EnteringGarage" then
				if MyCraneBooth.TruckParkY-MyHeadLights <= 0 then
					timePerUpdate=0
					BlinkLight()
					TurnIn()
				end
			elseif this.VehicleState == "LeavingGarage" then
				timePerUpdate=randomUpdateTimer
				BlinkLight()
				if MyMarker ~= nil and MyMarker.TotalGates ~= nil and Get(MyMarker,"GatePosY"..this.RepairedLimoGate)-MyHeadLights > 1 then
					this.VelX = 0
					this.VelY = 1.5
				elseif MyVehicleInFront ~= nil and MyVehicleInFront.SubType ~= nil and VehicleTailLights - MyHeadLights <= 8.5 then
					this.VelX = 0
					this.VelY = 0
				elseif MyMarker ~= nil and MyMarker.TotalGates ~= nil and Get(MyMarker,"Authorized"..this.RepairedLimoGate) ~= this.HomeUID then
					timePerUpdate = 1
					WaitForGateToOpen()
				elseif MyMarker ~= nil and MyMarker.TotalGates ~= nil and Get(MyMarker,"Authorized"..this.RepairedLimoGate) == this.HomeUID then
					if Exists(MySideLaneTrafficLight) then MySideLaneTrafficLight.SubType = 1 end
					timePerUpdate=0
					TurnOut()
				end
			elseif this.VehicleState == "Leaving" then
				if this.Pos.y >= this.MapBottom then
					CloseGatesBehindMe(true)
					DeleteMyCargo()
					this.Delete()
				end
				timePerUpdate=randomUpdateTimer
				if MyMarker ~= nil and MyMarker.TotalGates ~= nil and this.GateCount > 1 and MyTailLights - Get(MyMarker,"GatePosY"..this.RepairedLimoGate) >= 1 and Get(MyMarker,"Authorized"..this.RepairedLimoGate)==this.HomeUID then
					if Exists(MySideLaneTrafficLight) then MySideLaneTrafficLight.SubType = 0 end
					CloseGatesBehindMe()
				else
					Drive()
				end
			end
			
			Object.ApplyVelocity(this,this.VelX,this.VelY,false)
			
			if MyMarker ~= nil and MyMarker.TotalGates ~= nil then
				local tmpGC = this.GateCount
				local tmpDistG = 0
				if Get(MyMarker,"GatePosY"..this.GateCount) ~= nil then tmpDistG = Get(MyMarker,"GatePosY"..this.GateCount) - MyHeadLights end
				local tmpBehind = "none"
				local tmpDistB = 0
				if MyVehicleBehind ~= nil and MyVehicleBehind.SubType ~= nil then tmpBehind = MyVehicleBehind.HomeUID; tmpDistB = MyTailLights - VehicleHeadLights end
				local tmpFront = "none"
				local tmpDistF = 0
				if MyVehicleInFront ~= nil and MyVehicleInFront.SubType ~= nil then tmpFront = MyVehicleInFront.HomeUID; tmpDistF = VehicleTailLights - MyHeadLights end
				
				if MyMarker.TotalGates >= this.GateCount then
					this.Tooltip="\nVehicle ID: "..this.HomeUID.."\n\nCrane ID: "..this.CraneUID.."\n\nStatus: "..this.VehicleState.."\n\nDistance to gate ("..tmpGC..") is: "..tmpDistG.."\n\nVehicle Speed: "..this.VelY.."\n\nVehicle behind me: "..tmpBehind.."\nDistance: "..tmpDistB.."\n\nVehicle in front: "..tmpFront.."\nDistance: "..tmpDistF
				else
					this.Tooltip="\nVehicle ID: "..this.HomeUID.."\n\nCrane ID: "..this.CraneUID.."\n\nStatus: "..this.VehicleState.."\n\nVehicle Speed: "..this.VelY.."\n\nVehicle behind me: "..tmpBehind.."\nDistance: "..tmpDistB.."\n\nVehicle in front: "..tmpFront.."\nDistance: "..tmpDistF
				end
			else
				if MarkerFound==true then	-- marker got replaced by a new one, delete vehicle
					Interface.RemoveComponent(this,"SeparatorTruck")
					Interface.RemoveComponent(this,"DeleteTruck")
					Set(MyCraneBooth,"UnloadTruckSlot0",false)
					Set(MyCraneBooth,"UnloadTruckSlot1",false)
					Set(MyCraneBooth,"UnloadEngineSlot0",false)
					Set(MyCraneBooth,"UnloadEngineSlot1",false)
					if Get(this,"PartsSpawned") == true then
						Set(MyCraneBooth,"PartsTruckArriving",nil)
					else
						Set(MyCraneBooth,"LimoTruckArriving",nil)
					end
					nearbyObject = Find("TowTruck2Driver",50)
					if next(nearbyObject) then
						for thatEntity, distance in pairs(nearbyObject) do
							if Get(thatEntity,"HomeUID") == Get(this,"CraneUID") and Get(thatEntity,"TruckID") == this.Id.i then
								thatEntity.Delete()
							end
						end
					end
					DeleteMyCargo()
					this.Delete()
				end							-- else there were no markers at all, so do nothing
			end
		elseif not Get(this,"ReadyToLeave") then
			if Get(MyCraneBooth,"GarageIsFull") == true and Get(this,"LimoSpawned") == true then			-- limo truck
				--print("GarageIsFull, leaving")
				Set(MyCraneBooth,"UnloadTruckSlot0",false)
				Set(MyCraneBooth,"UnloadTruckSlot1",false)
				Set(this,"UnloadTruckSlot0",false)
				Set(this,"UnloadTruckSlot1",false)
				FindMyUnloadedCargo()
			end
			if Get(MyCraneBooth,"PartsRackIsFull") == true and Get(this,"PartsSpawned") == true then	-- engines truck
				--print("PartsRackIsFull, leaving")
				Set(MyCraneBooth,"UnloadEngineSlot0",false)
				Set(MyCraneBooth,"UnloadEngineSlot1",false)
				Set(this,"UnloadEngineSlot0",false)
				Set(this,"UnloadEngineSlot1",false)
				FindMyUnloadedCargo()
			end
			if Get(this,"PartsSpawned") == true and this.UnloadEngineSlot0 == false and this.UnloadEngineSlot1 == false then
				if MyCraneBooth.IsMilitary == "Yes" then
					Object.CreateJob(this,"TruckDriverLeavingMilitary")
				else
					Object.CreateJob(this,"TruckDriverLeaving")
				end
				Set(this,"ReadyToLeave",true)
			end
			if Get(this,"LimoSpawned") == true and this.UnloadTruckSlot0 == false and this.UnloadTruckSlot1 == false then
				if MyCraneBooth.IsMilitary == "Yes" then
					Object.CreateJob(this,"TruckDriverLeavingMilitary")
				else
					Object.CreateJob(this,"TruckDriverLeaving")
				end
				Set(this,"ReadyToLeave",true)
			end
		end
	end
end

function FindNextGateNr()
	--print("FindNextGateNr")
	Set(this,"MarkerUID",nil)
	FindMyRoadMarker(3)
	for i=1,10 do
		--print("comparing: "..Get(MyMarker,"GatePosY"..i).." with "..this.Pos.y)
		if MyMarker ~= nil and MyMarker.TotalGates ~= nil and Get(MyMarker,"GatePosY"..i) ~= nil then
			if this.Pos.y <= Get(MyMarker,"GatePosY"..i) then
				if i ~= this.GateCount then
					--print("Gate count was"..this.GateCount..", setting to "..i)
					Set(this,"GateCount",i)
				end
				Set(this,"RepairedLimoGate",i)
				break
			end
			--print("gatecount: "..this.GateCount)
		end
	end
end

function JobComplete_TruckDriverLeaving()
	if timePerUpdate==nil then
		Init()
	end
	timePerUpdate=randomUpdateTimer
	if MyMarker ~= nil and MyMarker.GarageTraffic == nil then FindMyRoadMarker() end -- marker got replaced, find new
	FindNextGateNr()
	Set(this,"VehicleState","LeavingGarage")
	FindVehicleInFront()
	FindVehicleBehindMe()
	if Get(this,"PartsSpawned") == true then
		Set(MyCraneBooth,"PartsTruckArriving",nil)
	else
		Set(MyCraneBooth,"LimoTruckArriving",nil)
	end
    nearbyObject = Find("TowTruck2Driver",5)
	if next(nearbyObject) then
		for thatEntity, distance in pairs(nearbyObject) do
			--if Get(thatEntity,"HomeUID") == Get(this,"CraneUID") and Get(thatEntity,"TruckID") == this.Id.i then
				thatEntity.Delete() -- just get rid of 1 truck driver since a driver from another truck could have taken the job
				break
			--end
		end
	end
end

function JobComplete_TruckDriverLeavingMilitary()
	if timePerUpdate==nil then
		Init()
	end
	timePerUpdate=randomUpdateTimer
	if MyMarker ~= nil and MyMarker.GarageTraffic == nil then FindMyRoadMarker() end -- marker got replaced, find new
	FindNextGateNr()
	Set(this,"VehicleState","LeavingGarage")
	FindVehicleInFront()
	FindVehicleBehindMe()
	if Get(this,"PartsSpawned") == true then
		Set(MyCraneBooth,"PartsTruckArriving",nil)
	else
		Set(MyCraneBooth,"LimoTruckArriving",nil)
	end
    nearbyObject = Find("TowTruck2DriverMilitary",5)
	if next(nearbyObject) then
		for thatEntity, distance in pairs(nearbyObject) do
			--if Get(thatEntity,"HomeUID") == Get(this,"CraneUID") and Get(thatEntity,"TruckID") == this.Id.i then
				thatEntity.Delete() -- just get rid of 1 truck driver since a driver from another truck could have taken the job
				break
			--end
		end
	end
end


function Exists(theObject)
	if theObject ~= nil and theObject.SubType ~= nil then
		return true
	else
		return false
	end
end
